(* This file was originally generated by why.
   It can be modified; only the generated parts will be overwritten. *)

Require Export comput1.
Require Export "convergence".
Require Export jessie_why.
Require Export Derive.
Open Local Scope Z_scope.

Local Coercion FtoRradix: Float.float >-> R.

(** DERIVE function is defined as a total function, but its only property 
    is its correctness when the input is derivable. *)

Definition DERIVE:= Derive.

Lemma DERIVE_def: forall f (H:derivable f) x, DERIVE f x = derive f H x.
intros f H x.
unfold DERIVE.
apply is_derive_unique.
apply derive_pt_eq_1 with (H x).
reflexivity.
Qed.




Let Derx:= fun f (X:R*R) => DERIVE (fun z => f (z,(snd X))) (fst X).
Let Dery:= fun f (X:R*R) => DERIVE (fun z => f ((fst X),z)) (snd X).

Lemma derivable_eq: forall f1 f2, derivable f1 -> (forall x, f1 x = f2 x) 
    -> derivable f2.
intros f1 f2 H H1.
unfold derivable; intros x.
exists (proj1_sig (H x)). 
unfold derivable, derivable_pt, derivable_pt_abs, derivable_pt_lim in *.
destruct (H x) as (l,Hl).
intros eps Heps.
destruct (Hl eps Heps) as (delta, Hdelta).
exists delta; intros h Hh1 Hh2.
rewrite <- 2!H1.
apply Hdelta; assumption.
Defined.


Lemma DERIVE_eq: forall f1 f2 z, derivable f1 -> (forall x, f1 x = f2 x) 
               -> DERIVE f1 z = DERIVE f2 z.
intros f1 f2 z H1 H3.
rewrite (DERIVE_def f1 H1).
rewrite (DERIVE_def f2 (derivable_eq f1 f2 H1 H3)).
reflexivity.
Qed.


  
(** First Why definitions *)
								   
(*Why type*) Definition doubleP: Set.
Admitted.

(*Why type*) Definition double_xP: Set.
Admitted.
								   
(*Why type*) Definition int32: Set.
Admitted.


(*Why logic*) Definition C_3 : R.
Admitted.

(*Why logic*) Definition C_4 : R.
Admitted.

(*Why logic*) Definition T_max : R.
Admitted.

(*Why axiom*) Lemma T_max_pos : (Rlt (0)%R T_max).
Admitted.
								   
(*Why logic*) Definition alpha_3 : R.
Admitted.

(*Why logic*) Definition alpha_4 : R.
Admitted.

(*Why logic*) Definition c : R.
Admitted.

(*Why axiom*) Lemma c_pos : (Rlt (0)%R c).
Admitted.
								   
(*Why logic*) Definition integer_of_int32 : int32 -> Z.
Admitted.

(*Why logic*) Definition p0 : R -> R.
Admitted.

(*Why logic*) Definition psol : R -> R -> R.
Admitted.

(*Why logic*) Definition psol_1 : R -> R -> R.
Admitted.

(*Why logic*) Definition psol_11 : R -> R -> R.
Admitted.
								   
(*Why axiom*) Lemma psol_1_def :
  (forall (x_2_0:R),
   (forall (t_1:R),
    (forall (eps:R),
     (exists C:R, (Rlt (0)%R C) /\
      (forall (dx:R),
       ((Rlt (0)%R eps) ->
        ((Rlt (Rabs dx) C) ->
         (Rlt
          (Rabs
           (Rminus
            (Rdiv (Rminus (psol (Rplus x_2_0 dx) t_1) (psol x_2_0 t_1)) dx) (
            psol_1 x_2_0 t_1)))
          eps)))))))).
Admitted.

(*Why axiom*) Lemma psol_11_def :
  (forall (x_4:R),
   (forall (t_3:R),
    (forall (eps_0:R),
     (exists C_0:R, (Rlt (0)%R C_0) /\
      (forall (dx_0:R),
       ((Rlt (0)%R eps_0) ->
        ((Rlt (Rabs dx_0) C_0) ->
         (Rlt
          (Rabs
           (Rminus
            (Rdiv
             (Rminus (psol_1 (Rplus x_4 dx_0) t_3) (psol_1 x_4 t_3)) dx_0) (
            psol_11 x_4 t_3)))
          eps_0)))))))).
Admitted.

(*Why logic*) Definition psol_2 : R -> R -> R.
Admitted.

(*Why logic*) Definition psol_22 : R -> R -> R.
Admitted.

(*Why axiom*) Lemma psol_2_def :
  (forall (x_6:R),
   (forall (t_5:R),
    (forall (eps_1:R),
     (exists C_1:R, (Rlt (0)%R C_1) /\
      (forall (dt_0:R),
       ((Rlt (0)%R eps_1) ->
        ((Rlt (Rabs dt_0) C_1) ->
         (Rlt
          (Rabs
           (Rminus
            (Rdiv (Rminus (psol x_6 (Rplus t_5 dt_0)) (psol x_6 t_5)) dt_0) (
            psol_2 x_6 t_5)))
          eps_1)))))))).
Admitted.

(*Why axiom*) Lemma psol_22_def :
  (forall (x_8:R),
   (forall (t_7:R),
    (forall (eps_2:R),
     (exists C_2:R, (Rlt (0)%R C_2) /\
      (forall (dt_0_0:R),
       ((Rlt (0)%R eps_2) ->
        ((Rlt (Rabs dt_0_0) C_2) ->
         (Rlt
          (Rabs
           (Rminus
            (Rdiv
             (Rminus (psol_2 x_8 (Rplus t_7 dt_0_0)) (psol_2 x_8 t_7)) dt_0_0) (
            psol_22 x_8 t_7)))
          eps_2)))))))).
Admitted.
								   
(*Why axiom*) Lemma psol_le :
  (forall (x_16:R),
   (forall (t_15:R),
    ((Rle (0)%R x_16) /\ (Rle x_16 (1)%R) ->
     ((Rle (0)%R t_15) -> (Rle (Rabs (psol x_16 t_15)) (1)%R))))).
Admitted.


(*Why logic*) Definition psol_Taylor_3 : R -> R -> R -> R -> R.
intros x t dx dt.
exact (DL_pol Derx Dery 2 (fun X : R * R => psol (fst X) (snd X)) (x, t) (dx, dt)).
Defined.

(*Why logic*) Definition psol_Taylor_4 : R -> R -> R -> R -> R.
intros x t dx dt.
exact (DL_pol Derx Dery 3 (fun X : R * R => psol (fst X) (snd X)) (x, t) (dx, dt)).
Defined.
								   
(*Why axiom*) Lemma psol_suff_regular_3 :
  (Rlt (0)%R alpha_3) /\ (Rlt (0)%R C_3) /\
  (forall (x_14:R),
   (forall (t_13:R),
    (forall (dx_3:R),
     (forall (dt_3:R),
      ((Rle (0)%R x_14) /\ (Rle x_14 (1)%R) ->
       ((Rle (sqrt (Rplus (Rmult dx_3 dx_3) (Rmult dt_3 dt_3))) alpha_3) ->
        (Rle
         (Rabs
          (Rminus
           (psol (Rplus x_14 dx_3) (Rplus t_13 dt_3)) (psol_Taylor_3
                                                       x_14 t_13 dx_3 dt_3)))
         (Rmult
          C_3 (Rabs
               (Rpower (sqrt (Rplus (Rmult dx_3 dx_3) (Rmult dt_3 dt_3)))
                (3)%R)))))))))).
Admitted.

(*Why axiom*) Lemma psol_suff_regular_4 :
  (Rlt (0)%R alpha_4) /\ (Rlt (0)%R C_4) /\
  (forall (x_15:R),
   (forall (t_14:R),
    (forall (dx_4:R),
     (forall (dt_4:R),
      ((Rle (0)%R x_15) /\ (Rle x_15 (1)%R) ->
       ((Rle (sqrt (Rplus (Rmult dx_4 dx_4) (Rmult dt_4 dt_4))) alpha_4) ->
        (Rle
         (Rabs
          (Rminus
           (psol (Rplus x_15 dx_4) (Rplus t_14 dt_4)) (psol_Taylor_4
                                                       x_15 t_14 dx_4 dt_4)))
         (Rmult
          C_4 (Rabs
               (Rpower (sqrt (Rplus (Rmult dx_4 dx_4) (Rmult dt_4 dt_4)))
                (4)%R)))))))))).
Admitted.	
							   
(*Why predicate*) Definition separated_matrix  (p_1:(pointer double_xP)) (leni:Z) (double_xP_double_xM_p_1_2_at_L:(memory double_xP (pointer doubleP)))
  := (forall (i_3:Z),
      (forall (j_0:Z),
       (0 <= i_3 /\ i_3 < leni ->
        (0 <= j_0 /\ j_0 < leni ->
         (i_3 <> j_0 ->
          ~(same_block
            (select double_xP_double_xM_p_1_2_at_L (shift p_1 i_3)) (
            select double_xP_double_xM_p_1_2_at_L (shift p_1 j_0)))))))).
     

(*Why function*) Definition sqr  (x_17:R) := (Rmult x_17 x_17).


(*Why axiom*) Lemma wave_eq_0 :
  (forall (x_9:R),
   ((Rle (0)%R x_9) /\ (Rle x_9 (1)%R) -> (eq (psol x_9 (0)%R) (p0 x_9)))).
Admitted.

(*Why axiom*) Lemma wave_eq_1 :
  (forall (x_10:R),
   ((Rle (0)%R x_10) /\ (Rle x_10 (1)%R) -> (eq (psol_2 x_10 (0)%R) (0)%R))).
Admitted.

(*Why axiom*) Lemma wave_eq_2 :
  (forall (x_11:R),
   (forall (t_8:R),
    ((Rle (0)%R x_11) /\ (Rle x_11 (1)%R) ->
     (eq (Rminus (psol_22 x_11 t_8) (Rmult (Rmult c c) (psol_11 x_11 t_8))) (0)%R)))).
Admitted.


(*Why axiom*) Lemma wave_eq_dirichlet_1 :
  (forall (t_9:R), (eq (psol (0)%R t_9) (0)%R)).
Admitted.


(*Why axiom*) Lemma wave_eq_dirichlet_2 :
  (forall (t_10:R), (eq (psol (1)%R t_10) (0)%R)).
Admitted.
								   

(** Definition of the average of the convergence error *)

(*Why logic*) Definition sqr_norm_dx_conv_err :
  (pointer double_xP) -> R -> R -> Z -> Z -> Z
  -> (memory double_xP (pointer doubleP)) -> (memory doubleP double) -> R.
intros p dx dt ni i k mem1 mem2.
pose (accM  := 
 fun (i j:Z) => select mem2 (shift (select mem1 (shift p i)) j)).
exact (dx * squared_norm_n (Zabs_nat i) 
      (fun z => (psol (z / ni) (k*dt) - double_exact (accM z k))))%R.
Defined. 
								   
(*Why function*) Definition norm_dx_conv_err  (p_5:(pointer double_xP)) (dt_10:R) (ni_4:Z) (k_4:Z) (double_xP_double_xM_p_5_4_at_L:(memory double_xP (pointer doubleP))) (doubleP_doubleM_double_xM_22_at_L:(memory doubleP double))
  := (sqrt
      (sqr_norm_dx_conv_err
       p_5 (Rdiv (1)%R (IZR ni_4)) dt_10 ni_4 ni_4 k_4 double_xP_double_xM_p_5_4_at_L doubleP_doubleM_double_xM_22_at_L)).


Lemma norm_dx_conv_err_eq: forall  p dt ni k mem1 mem2, 0 <= k -> ni <> 0 ->
    norm_dx_conv_err p dt ni k mem1 mem2 = 
    finite_norm_dx 0 1 (/ni)
         (fun z => convergence_error 0 (fun X => psol (fst X) (snd X)) 
                  (fun _ j k => double_exact (select mem2 (shift (select mem1 (shift p j)) k)))
                  (/ni,dt) z (Zabs_nat k)).
intros.
unfold norm_dx_conv_err, finite_norm_dx.
apply f_equal.
unfold sqr_norm_dx_conv_err, finite_squared_norm_dx.
unfold squared_norm_n, finite_dot_product_dx.
unfold Rdiv at 1; rewrite Rmult_1_l.
apply f_equal.
replace (R_n.ni 0 1 (/ ni)) with ni.
assert (forall i : Z, 0 <= i < Zabs_nat ni ->
(psol (i / ni) (k * dt) -
 double_exact (select mem2 (shift (select mem1 (shift p i)) k)))%R =
convergence_error 0 (fun X : R * R => psol (fst X) (snd X))
  (fun (_ : R * R) (j : Z) (k0 : nat) =>
   double_exact (select mem2 (shift (select mem1 (shift p j)) k0)))
  (/ ni, dt) i (Zabs_nat k)).
intros i Hi.
unfold convergence_error, ubar, discretization, Xjk; simpl.
rewrite Rplus_0_l; unfold Rdiv.
replace (Z_of_nat (Zabs_nat k)) with k.
replace (INR (Zabs_nat k)) with (IZR k).
reflexivity.
rewrite INR_IZR_INZ,inj_abs; auto.
rewrite inj_abs; auto.
apply trans_eq with 
 (dot_product_n (Zabs_nat ni)
  (fun z : Z =>
   (psol (z / ni) (k * dt) -
    double_exact (select mem2 (shift (select mem1 (shift p z)) k)))%R)
 (fun z : Z =>
   convergence_error 0 (fun X : R * R => psol (fst X) (snd X))
     (fun (_ : R * R) (j : Z) (k0 : nat) =>
      double_exact (select mem2 (shift (select mem1 (shift p j)) k0)))
     (/ ni, dt) z (Zabs_nat k))).
apply dot_product_n_eq_suf_r; auto.
apply dot_product_n_eq_suf_l; auto.
unfold R_n.ni, jx.
replace (((1 - 0) / / ni))%R with (IZR ni).
apply sym_eq; apply Int_part_IZR.
field; auto with real zarith.
Qed.

(* Why obligation from file "dirichlet.c", line 108, characters 4-195: *)
(*Why goal*) Lemma sqr_norm_dx_conv_err_0 : 
  (forall (double_xP_double_xM_p_3_14_at_L:(memory double_xP (pointer doubleP))),
   (forall (doubleP_doubleM_double_xM_28_at_L:(memory doubleP double)),
    (forall (p_3:(pointer double_xP)),
     (forall (dx_6:R),
      (forall (dt_8:R),
       (forall (ni_2:Z),
        (forall (k_2:Z),
         (eq (sqr_norm_dx_conv_err
              p_3 dx_6 dt_8 ni_2 0 k_2 double_xP_double_xM_p_3_14_at_L doubleP_doubleM_double_xM_28_at_L) (0)%R)))))))).
Proof.
intros mem1 mem2 p dx dt ni k.
apply trans_eq with (dx*0)%R;[idtac| ring].
unfold sqr_norm_dx_conv_err; apply f_equal.
unfold squared_norm_n; simpl; auto.
Save.

(* Why obligation from file "dirichlet.c", line 112, characters 4-350: *)
(*Why goal*) Lemma sqr_norm_dx_conv_err_succ : 
  (forall (double_xP_double_xM_p_4_15_at_L:(memory double_xP (pointer doubleP))),
   (forall (doubleP_doubleM_double_xM_16_at_L:(memory doubleP double)),
    (forall (p_4:(pointer double_xP)),
     (forall (dx_7:R),
      (forall (dt_9:R),
       (forall (ni_3:Z),
        (forall (i_3:Z),
         (forall (k_3:Z),
          (0 <= i_3 ->
           (eq (sqr_norm_dx_conv_err
                p_4 dx_7 dt_9 ni_3 (i_3 + 1) k_3 double_xP_double_xM_p_4_15_at_L doubleP_doubleM_double_xM_16_at_L) (
            Rplus
            (sqr_norm_dx_conv_err
             p_4 dx_7 dt_9 ni_3 i_3 k_3 double_xP_double_xM_p_4_15_at_L doubleP_doubleM_double_xM_16_at_L) (
            Rmult
            dx_7 (sqr
                  (Rminus
                   (psol
                    (Rdiv (Rmult (1)%R (IZR i_3)) (IZR ni_3)) (Rmult
                                                               (IZR k_3) dt_9)) (
                   double_exact
                   (select
                    doubleP_doubleM_double_xM_16_at_L (shift
                                                       (select
                                                        double_xP_double_xM_p_4_15_at_L (
                                                        shift p_4 i_3)) k_3))))))))))))))))).
Proof.
intros mem1 mem2 p dx dt ni k i Hi.
unfold sqr_norm_dx_conv_err.
rewrite <- Rmult_plus_distr_l; apply f_equal.
replace (k+1) with (Zsucc k) by reflexivity.
rewrite absolu_Zs; auto.
unfold squared_norm_n; simpl.
rewrite Rplus_comm; apply Rplus_eq_compat_l.
replace (Z_of_nat (Zabs_nat k)) with k.
rewrite Rmult_1_l.
unfold sqr; ring.
rewrite inj_abs; auto.
Save.

(** End of first Why definitions *)

(** Derive *)

Lemma derivable_psol_1:
   forall x, derivable (fun z => psol z x).
unfold derivable, derivable_pt, derivable_pt_abs, derivable_pt_lim; intros x y.
exists (psol_1 y x).
intros eps Heps.
destruct (psol_1_def y x eps) as (delta,(Hdelta1,Hdelta2)).
exists (mkposreal delta Hdelta1).
intros h Hh1 Hh2.
apply Hdelta2; auto with real.
Defined.


Lemma derive_psol_1:
  forall x y, derive (fun z => psol z y) (derivable_psol_1 y) x = psol_1 x y.
intros x y.
unfold derive, derive_pt, derivable_psol_1.
now simpl.
Qed.


Lemma derivable_psol_2:
   forall x, derivable (fun z => psol x z).
unfold derivable, derivable_pt, derivable_pt_abs, derivable_pt_lim; intros y x.
exists (psol_2 y x).
intros eps Heps.
destruct (psol_2_def y x eps) as (delta,(Hdelta1,Hdelta2)).
exists (mkposreal delta Hdelta1).
intros h Hh1 Hh2.
apply Hdelta2; auto with real.
Defined.


Lemma derive_psol_2:
  forall x y, derive (fun z => psol x z) (derivable_psol_2 x) y = psol_2 x y.
intros x y.
unfold derive, derive_pt, derivable_psol_2.
now simpl.
Qed.

Lemma derivable_psol_11:
   forall x, derivable (fun z => psol_1 z x).
unfold derivable, derivable_pt, derivable_pt_abs, derivable_pt_lim; intros x y.
exists (psol_11 y x).
intros eps Heps.
destruct (psol_11_def y x eps) as (delta,(Hdelta1,Hdelta2)).
exists (mkposreal delta Hdelta1).
intros h Hh1 Hh2.
apply Hdelta2; auto with real.
Defined.


Lemma derive_psol_11:
  forall x y, derive (fun z => psol_1 z y) (derivable_psol_11 y) x = psol_11 x y.
intros x y.
unfold derive, derive_pt, derivable_psol_1.
now simpl.
Qed.


Lemma derivable_psol_22:
   forall x, derivable (fun z => psol_2 x z).
unfold derivable, derivable_pt, derivable_pt_abs, derivable_pt_lim; intros y x.
exists (psol_22 y x).
intros eps Heps.
destruct (psol_22_def y x eps) as (delta,(Hdelta1,Hdelta2)).
exists (mkposreal delta Hdelta1).
intros h Hh1 Hh2.
apply Hdelta2; auto with real.
Defined.


Lemma derive_psol_22:
  forall x y, derive (fun z => psol_2 x z) (derivable_psol_22 x) y = psol_22 x y.
intros x y.
unfold derive, derive_pt, derivable_psol_22.
now simpl.
Qed.



Lemma is_solution_psol: is_solution 0 1 Derx Dery c p0 (fun _ : R => Z0) (fun _ : R * R => Z0)
  (fun X : R * R => psol (fst X) (snd X)).
repeat split; simpl.
intros; unfold L.
rewrite <- (wave_eq_2 (fst X) (snd X)); auto.
apply f_equal2.
simpl; unfold Dery; simpl.
rewrite <- derive_psol_22.
rewrite <- DERIVE_def.
apply sym_eq.
apply DERIVE_eq.
apply derivable_psol_22.
intros.
rewrite <- derive_psol_2.
rewrite <- DERIVE_def; auto.
unfold pow; rewrite Rmult_1_r.
apply Rmult_eq_compat_l.
simpl; unfold Derx; simpl.
rewrite <- derive_psol_11.
rewrite <- DERIVE_def.
apply sym_eq; apply DERIVE_eq.
apply derivable_psol_11.
intros.
rewrite <- derive_psol_1.
rewrite <- DERIVE_def; auto.
intros; unfold L1.
rewrite <- (wave_eq_1 x) at 2; auto.
unfold Dery; simpl.
rewrite <- derive_psol_2.
rewrite <- DERIVE_def; auto.
intros; unfold L0.
rewrite <- (wave_eq_0 x); auto.
intros; apply wave_eq_dirichlet_1.
intros; apply wave_eq_dirichlet_2.
Qed.

Lemma psol_reg_3: is_sufficiently_regular_n 0 1 Derx Dery 3
    (fun X : R * R => psol (fst X) (snd X)).
generalize psol_suff_regular_3; intros (H1,(H2,H3)).
unfold is_sufficiently_regular_n, OuP.
exists alpha_3; exists C_3; split; trivial; split; trivial.
intros ((x,Hx),t) (dx,dt); intros Hdxt _.
unfold subtract2_fun; simpl.
unfold my_proj; simpl.
unfold psol_Taylor_3 in H3.
assert (0 <= norm_l2 (dx,dt))%R.
unfold norm_l2; apply Reals_compl.sqrt_pos.
case H; intros H'.
apply Rle_trans with (C_3 * Rabs (Rpower (sqrt (dx * dx + dt * dt)) 3))%R.
apply H3; auto.
unfold norm_l2 in Hdxt; simpl in Hdxt; auto with real.
right; apply f_equal; apply f_equal.
replace 3%R with (INR 3);[idtac|simpl; ring].
rewrite Rpower_pow.
unfold norm_l2, Rsqr; simpl; ring.
unfold norm_l2 in H'; simpl in H'; auto with real.
assert (dx=0%R).
case (Req_dec dx 0); auto.
intros; absurd (0 < norm_l2 (dx,dt))%R.
rewrite <- H'; auto with real.
apply norm_l2_pos_strict; auto with real.
intro; apply H0.
apply trans_eq with (fst ((dx, dt))); auto.
rewrite H4; auto.
assert (dt=0%R).
case (Req_dec dt 0); auto.
intros; absurd (0 < norm_l2 (dx,dt))%R.
rewrite <- H'; auto with real.
apply norm_l2_pos_strict; auto with real.
intro; apply H4.
apply trans_eq with (snd ((dx, dt))); auto.
rewrite H5; auto.
rewrite H0, H4.
apply Rle_trans with (Rabs 0).
right; apply f_equal.
rewrite 2!Rplus_0_r.
unfold DL_pol, differential, C; simpl.
apply trans_eq with (psol x t -
  partial_derive Derx Dery 0 0 (fun X : R * R => psol (fst X) (snd X)) (x, t))%R.
field.
unfold partial_derive, partial_derive_firstvar_n,partial_derive_secondvar_n.
simpl; ring.
unfold norm_l2; simpl.
unfold Rsqr; rewrite Rmult_0_l, Rplus_0_l, sqrt_0, Rmult_0_l, Rabs_R0.
right; ring.
Qed.


Lemma psol_reg_4: is_sufficiently_regular_n 0 1 Derx Dery 4
  (fun X : R * R => psol (fst X) (snd X)).
generalize psol_suff_regular_4; intros (H1,(H2,H3)).
unfold is_sufficiently_regular_n, OuP.
exists alpha_4; exists C_4; split; trivial; split; trivial.
intros ((x,Hx),t) (dx,dt); intros Hdxt _.
unfold subtract2_fun; simpl.
unfold my_proj; simpl.
unfold psol_Taylor_4 in H3.
assert (0 <= norm_l2 (dx,dt))%R.
unfold norm_l2; apply Reals_compl.sqrt_pos.
case H; intros H'.
apply Rle_trans with (C_4 * Rabs (Rpower (sqrt (dx * dx + dt * dt)) 4))%R.
apply H3; auto.
unfold norm_l2 in Hdxt; simpl in Hdxt; auto with real.
right; apply f_equal; apply f_equal.
replace 4%R with (INR 4);[idtac|simpl; ring].
rewrite Rpower_pow.
unfold norm_l2, Rsqr; simpl; ring.
unfold norm_l2 in H'; simpl in H'; auto with real.
assert (dx=0%R).
case (Req_dec dx 0); auto.
intros; absurd (0 < norm_l2 (dx,dt))%R.
rewrite <- H'; auto with real.
apply norm_l2_pos_strict; auto with real.
intro; apply H0.
apply trans_eq with (fst ((dx, dt))); auto.
rewrite H4; auto.
assert (dt=0%R).
case (Req_dec dt 0); auto.
intros; absurd (0 < norm_l2 (dx,dt))%R.
rewrite <- H'; auto with real.
apply norm_l2_pos_strict; auto with real.
intro; apply H4.
apply trans_eq with (snd ((dx, dt))); auto.
rewrite H5; auto.
rewrite H0, H4.
apply Rle_trans with (Rabs 0).
right; apply f_equal.
rewrite 2!Rplus_0_r.
unfold DL_pol, differential, C; simpl.
apply trans_eq with (psol x t -
  partial_derive Derx Dery 0 0 (fun X : R * R => psol (fst X) (snd X)) (x, t))%R.
field.
unfold partial_derive, partial_derive_firstvar_n,partial_derive_secondvar_n.
simpl; ring.
unfold norm_l2; simpl.
unfold Rsqr; rewrite Rmult_0_l, Rplus_0_l, sqrt_0, Rmult_0_l, Rabs_R0.
right; ring.
Qed.

Let p0h := (fun dX j => p0 (fst (Xjk 0 dX j 0))).

(** Other Why definitions: C_conv and alpha_conv *)
								   
(*Why logic*) Definition C_conv : R.
specialize (convergence 0 1%R T_max Rlt_0_1 T_max_pos 
    Derx Dery
    c (fun X => psol (fst X) (snd X)) p0 (fun _ => 0) (fun _ => 0) 
    (my_unh 0 1 c p0h (fun _ _ => 0) (fun _ _ _ => 0))  (1 / 1125899906842624)%R).
intros T.
assert (scheme_is_convergent_of_order 0 1 T_max c
   (fun X : R * R => psol (fst X) (snd X))
   (my_unh 0 1 c p0h (fun (_ : R * R) (_ : Z) => Z0)
      (fun (_ : R * R) (_ : Z) (_ : nat) => Z0)) (1 / 1125899906842624) 2 2).
apply T; clear T; auto.
(* . *)
apply is_solution_psol.
intros dX; apply my_unh_correct.
apply c_pos.
clear.
split; unfold Rdiv; rewrite Rmult_1_l.
apply Rinv_0_lt_compat.
apply Rlt_le_trans with (IZR 1125899906842624).
apply Rlt_IZRO; auto with zarith.
rewrite <- Z2R_IZR.
right; reflexivity.
apply Rlt_le_trans with (/1)%R;[idtac|auto with real].
apply Rinv_lt_contravar.
rewrite Rmult_1_l.
apply Rlt_le_trans with (IZR 1125899906842624).
apply Rlt_IZRO; auto with zarith.
rewrite <- Z2R_IZR.
right; reflexivity.
apply Rle_lt_trans with (IZR 1).
auto with real zarith.
apply Rlt_le_trans with (IZR 1125899906842624).
auto with zarith real.
rewrite <- Z2R_IZR.
right; reflexivity.
apply psol_reg_3.
apply psol_reg_4.
(* *)
clear T; destruct H as (alp,(C,(Y1,(Y2,Y3)))).
exact C.
Defined.

Lemma C_conv_pos: (0 < C_conv)%R.
unfold C_conv.
destruct (convergence 0 1%R T_max Rlt_0_1 T_max_pos 
    Derx Dery
    c (fun X => psol (fst X) (snd X)) p0 (fun _ => 0) (fun _ => 0) 
    (my_unh 0 1 c p0h (fun _ _ => 0) (fun _ _ _ => 0))  (1 / 1125899906842624)%R).
destruct s.
apply Rlt_le_trans with x0.
apply a.
right.
case a; auto.
intros; case a0; auto.
Qed.


Definition alpha_aux : R.
specialize (convergence 0 1%R T_max Rlt_0_1 T_max_pos 
    Derx Dery
    c (fun X => psol (fst X) (snd X)) p0 (fun _ => 0) (fun _ => 0) 
    (my_unh 0 1 c p0h (fun _ _ => 0) (fun _ _ _ => 0))  (1 / 1125899906842624)%R).
intros T.
assert (scheme_is_convergent_of_order 0 1 T_max c
   (fun X : R * R => psol (fst X) (snd X))
   (my_unh 0 1 c p0h (fun (_ : R * R) (_ : Z) => Z0)
      (fun (_ : R * R) (_ : Z) (_ : nat) => Z0)) (1 / 1125899906842624) 2 2).
apply T; clear T; auto.
(* . *)
apply is_solution_psol.
intros dX; apply my_unh_correct.
apply c_pos.
clear.
split; unfold Rdiv; rewrite Rmult_1_l.
apply Rinv_0_lt_compat.
apply Rlt_le_trans with (IZR 1125899906842624).
apply Rlt_IZRO; auto with zarith.
rewrite <- Z2R_IZR.
right; reflexivity.
apply Rlt_le_trans with (/1)%R;[idtac|auto with real].
apply Rinv_lt_contravar.
rewrite Rmult_1_l.
apply Rlt_le_trans with (IZR 1125899906842624).
apply Rlt_IZRO; auto with zarith.
rewrite <- Z2R_IZR.
right; reflexivity.
apply Rle_lt_trans with (IZR 1).
auto with real zarith.
apply Rlt_le_trans with (IZR 1125899906842624).
auto with zarith real.
rewrite <- Z2R_IZR.
right; reflexivity.
apply psol_reg_3.
apply psol_reg_4.
(* *)
clear T; destruct H as (alp,(C,(Y1,(Y2,Y3)))).
exact alp.
Defined.

Lemma ln_monotone: forall x y : R, (0 < x)%R -> (x <= y)%R -> (ln x <= ln y)%R.
intros x y H1 H2; case H2; intros.
left; apply ln_increasing; auto.
right; rewrite H; auto.
Qed.

Lemma Rpower_Rpower: forall x y z, Rpower (Rpower x y) z = Rpower x (y*z).
intros; unfold Rpower.
rewrite ln_exp.
apply f_equal; ring.
Qed.


Lemma construct_alpha: forall M, (0 < M)%R ->  { alp:R |
   forall dx dt, (0 < dx)%R -> (0 <= dt)%R -> (sqrt(dx*dx+dt*dt) <= alp)%R -> 
      (dt / dx * c <= 1)%R ->
      ((dx*dx+dt*dt) / sqrt dx <=  M)%R }.
intros M H.
exists (Rpower (M / (1+1/(c*c))) (2/3)).
intros dx dt H1 H2 H3 H4.
generalize c_pos; intros H5.
assert (H6: (0 < ((1 + 1 / (c * c))))%R).
apply Rle_lt_trans with (0+0)%R; try apply Rplus_lt_compat; auto with real.
unfold Rdiv; rewrite Rmult_1_l; apply Rinv_0_lt_compat.
apply Rmult_lt_0_compat; auto with real.
apply Rle_trans with ((Rpower dx (3/2))*(1+1/(c*c)))%R.
apply Rmult_le_reg_l with (sqrt dx).
apply sqrt_lt_R0; auto.
apply Rle_trans with (dx * dx + dt * dt)%R.
right; field.
specialize (sqrt_lt_R0 _ H1); auto with real.
apply Rle_trans with (dx*dx + dx*dx/(c*c))%R.
apply Rplus_le_compat_l.
fold (Rsqr dt).
apply Rle_trans with (Rsqr (dx/c)).
apply Rsqr_incr_1; auto with real.
apply Rmult_le_reg_l with (c/dx)%R.
unfold Rdiv; apply Rlt_mult_inv_pos; auto with real.
apply Rle_trans with (dt/dx*c)%R.
right; unfold Rdiv; ring.
apply Rle_trans with (1:=H4).
right; field; split; auto with real.
apply Rmult_le_pos; auto with real.
right; unfold Rsqr, Rdiv; field; auto with real.
rewrite <- Rmult_assoc.
apply Rle_trans with ((dx*dx) * ((1 + 1 / (c * c))))%R.
right; unfold Rdiv; ring.
apply Rmult_le_compat_r; auto with real.
rewrite <- Rpower_sqrt; auto.
rewrite <- Rpower_plus.
replace (/2+3/2)%R with (1+1)%R by field.
rewrite Rpower_plus, Rpower_1; auto with real.
apply Rle_trans with (Rpower (Rpower (M / (1 + 1 / (c * c))) (2 / 3))
    (3 / 2) * (1 + 1 / (c * c)))%R.
apply Rmult_le_compat_r; auto with real.
unfold Rpower.
apply exp_monotone.
apply Rmult_le_compat_l.
unfold Rdiv; apply Rmult_le_pos; auto with real.
apply Rle_trans with 2%R; auto with real.
apply ln_monotone; auto.
apply Rle_trans with (sqrt (dx*dx+dt*dt)).
rewrite <- (sqrt_Rsqr dx) at 1; auto with real.
apply sqrt_le_1; auto with real.
apply Rle_trans with (0+0)%R; try apply Rplus_le_compat; 
  try apply Rmult_le_pos; auto with real.
apply Rle_trans with (dx*dx+0)%R.
unfold Rsqr; right; ring.
apply Rplus_le_compat_l; apply Rmult_le_pos; auto with real.
apply Rle_trans with (1:=H3).
right; reflexivity.
rewrite Rpower_Rpower.
replace (2 / 3 * (3 / 2))%R with 1%R.
rewrite Rpower_1.
right; field; split; auto with real.
assert (0 < c*c+1)%R; auto with real. 
apply Rle_lt_trans with (0+0)%R; try apply Rplus_lt_compat; auto with real.
apply Rmult_lt_0_compat; auto with real.
unfold Rdiv; apply Rlt_mult_inv_pos; auto.
field.
Defined.


(*Why logic*) Definition alpha_conv : R.
assert (0 < /(2*C_conv))%R.
apply Rinv_0_lt_compat; apply Rmult_lt_0_compat; auto with real.
apply C_conv_pos.
exact (Rmin alpha_aux (Rmin (proj1_sig (construct_alpha (/(2*C_conv)) H)) 1)).
Defined.

Lemma alpha_conv_le1: (alpha_conv <= 1)%R.
unfold alpha_conv.
apply Rle_trans with (1:= Rmin_r _ _).
apply Rmin_r.
Qed.
				     
(* Why obligation from file "dirichlet.c", line 74, characters 4-41: *)
(*Why goal*) Lemma alpha_conv_pos : 
  (Rlt (0)%R alpha_conv).
Proof.
unfold alpha_conv.
apply Rmin_pos.
unfold alpha_aux.
destruct (convergence 0 1%R T_max Rlt_0_1 T_max_pos 
    Derx Dery
    c (fun X => psol (fst X) (snd X)) p0 (fun _ => 0) (fun _ => 0) 
    (my_unh 0 1 c p0h (fun _ _ => 0) (fun _ _ _ => 0))  (1 / 1125899906842624)%R).
destruct s.
apply Rlt_le_trans with x.
apply a.
right.
case a; auto.
intros; case a0; auto.
apply Rmin_pos; auto with real.
simpl; unfold Rpower.
apply exp_pos.
Save.		


(** analytic_error *)

Lemma Zdichotomy: 
  forall n m : Z, {n <= m} + {m < n}.
intros.
case (Ztrichotomy_inf n m); auto with zarith.
intros T; case T; left; auto with zarith.
Qed.


Definition eps_aux1: 
  (pointer double_xP) -> Z -> double
  -> (memory double_xP (pointer doubleP))
  -> (memory doubleP double) -> Z -> Z -> R.
intros p ni a mem1 mem2 i k.
pose (accM  := 
 fun (l j:Z) => double_value(select mem2 (shift (select mem1 (shift p l)) j))).
pose (accMDiff  := 
 fun (l j:Z) => (double_exact (select mem2 (shift (select mem1 (shift p l)) j))
      - double_value(select mem2 (shift (select mem1 (shift p l)) j)))%R).
case (Zdichotomy 1 i); intros.
case (Zdichotomy i (ni-1)); intros.
case (Zdichotomy k 0); intros.
exact (accMDiff i 0%Z).
case (Zdichotomy k 1); intros.
exact (-((accM i 1%Z - (accM i 0%Z + /2*double_exact a *
     (accM (i+1)%Z 0%Z+accM (i-1)%Z 0%Z 
        -2*accM i 0%Z))) + (double_exact a/2 * 
   (accMDiff (i+1)%Z 0%Z + accMDiff (i-1)%Z 0%Z))
   + (1-double_exact a) * accMDiff i 0%Z ))%R.
exact (-(accM i k - (2*accM i (k-1)%Z - accM i (k-2)%Z
   + (double_exact a*(accM (i+1)%Z (k-1)%Z -2*accM i (k-1)%Z
          +accM (i-1)%Z (k-1)%Z)))))%R.
exact 0%R.
exact 0%R.
Defined.




Definition eps_aux2 :
  (pointer double_xP) -> Z -> double
  -> (memory double_xP (pointer doubleP))
  -> (memory doubleP double) -> Z -> Z -> R.
intros p ni a mem1 mem2 i k.
pose (n:=Zmod (Zdiv i ni) 2).
case (Z_eq_dec n 0); intros.
exact (eps_aux1 p ni a mem1 mem2 (Zmod i ni) k).
exact (-(eps_aux1 p ni a mem1 mem2 (Zmod (ni-i) ni) k))%R.
Defined.

Definition eps :
  (pointer double_xP) -> Z -> double
  -> (memory double_xP (pointer doubleP))
  -> (memory doubleP double) -> Z -> Z -> R.
intros p ni a mem1 mem2  i k.
case (Zcompare 0 i).
exact (eps_aux2 p ni a mem1 mem2 i k).
exact (eps_aux2 p ni a mem1 mem2 i k).
exact (-(eps_aux2 p ni a mem1 mem2 (-i) k))%R.
Defined.


Lemma same_block_shift:
  forall (A1 : Set) (p q : pointer A1) (l:Z),
   p = shift q l -> same_block p q.
intros; rewrite H.
apply same_block_shift_left.
unfold same_block; reflexivity.
Qed.

Lemma separated_matrix_prop: 
     forall p mem1 mem2 ni i1 i2 k1 k2 (d:double),
    separated_matrix p ni mem1 ->
   (0 <= i1 < ni) ->  (0 <= i2 < ni) ->  
   (i1 <> i2)%Z  \/  (k1<>k2)%Z ->
   (select (store mem2 (shift (select mem1 (shift p i2)) k2) d) (shift (select mem1 (shift p i1)) k1))
     = select mem2 (shift (select mem1 (shift p i1)) k1).
intros.
apply select_store_neq.
assert (i1=i2 \/ i1 <> i2) by omega.
case H3; intros.
rewrite H4; apply neq_shift; auto with zarith.
unfold separated_matrix in H.
intro H5.
absurd (same_block (select mem1 (shift p i1)) (select mem1 (shift p i2))).
apply H; auto.
apply same_block_shift with (k2+-k1).
rewrite <- shift_shift.
rewrite H5.
rewrite shift_shift.
replace (k1+-k1) with 0 by ring.
now rewrite shift_zero.
Qed.


(*Why logic*) Definition analytic_error :
  (pointer double_xP) -> Z -> Z -> Z -> double -> double
  -> (memory double_xP (pointer doubleP)) -> (memory doubleP double) -> Prop.
intros p ni i k a dt mem1 mem2.
pose (accM  := 
 fun (i j:Z) => select mem2 (shift (select mem1 (shift p i)) j)).
pose (eps2 := (eps p ni a mem1 mem2)).
exact  (((0 <= i)%Z -> (0 <= k)%Z ->
   ((k=0)%Z -> (forall i1:Z, (0 <= i1 <= i) ->
      (Rabs (eps2 i1 0%Z) <= 14*powerRZ 2 (-52))%R)) /\
   ((0 < k)%Z -> (forall i1:Z, (0 <= i1 <= ni) ->
      (Rabs (eps2 i1 0%Z) <= 14*powerRZ 2 (-52))%R)) /\
    (forall i1 k1:Z,   
          (0 <= k1< k \/ (k1=k /\ 0 <= i1 <= i)) ->
          (Rabs (eps2 i1 k1) <= 78*powerRZ 2 (-52))%R)
   /\
   ((forall i1 k1:Z, 
     (0 <= i1 <= ni) ->
     (0 <= k1< k \/ (k1=k /\  i1 <= i))
          -> 
    (double_exact (accM i1 k1) - double_value (accM i1 k1) =
      Err (double_exact a) eps2 i1 k1)%R)) 
  /\
  (forall i1 k1:Z, 
     (0 <= i1 <= ni) ->
     (0 <= k1< k \/ (k1=k /\  i1 <= i))
          -> scheme 0 1 c p0h (fun _ _  =>0) (fun _ _ _ => 0)
            (fun _ l1 l2 => double_exact (accM l1 l2)) 
            (/IZR ni,double_exact dt) i1 (Zabs_nat k1)=0))).
Defined.



Lemma eps_eps_aux: forall p ni i k a mem1 mem2,
     0 < ni ->  
    0 <= i <= ni ->
    eps p ni a mem1 mem2 i k = eps_aux1 p ni a mem1 mem2 i k.
intros.
apply trans_eq with (eps_aux2 p ni a mem1 mem2 i k).
unfold eps.
generalize (Zcompare_correct 0 i).
case (Zcompare 0 i); simpl; auto; intros.
absurd (i < 0); auto with zarith.
unfold eps_aux2.
assert (i=ni \/ i < ni) by omega.
case H1.
intros N; rewrite N; unfold eps.
rewrite Z_div_same; auto with zarith.
replace (1 mod 2) with 1.
apply trans_eq with (-(eps_aux1 p ni a mem1 mem2 ((ni-ni) mod ni) k))%R; auto.
replace ((ni-ni) mod ni) with 0%Z.
unfold eps_aux1; simpl.
case (Zdichotomy 1 0).
intros; absurd (1 <= 0); auto with zarith.
case (Zdichotomy 1 ni).
2: intros; absurd (ni < 1); auto with zarith.
case (Zdichotomy ni (ni - 1)).
intros; absurd (ni <= ni - 1); auto with zarith.
intros; ring.
ring_simplify (ni-ni); unfold Zmod; simpl; auto.
assert (Zpos 1 = 1/2 * 2 + Zmod 1 2 /\ 0 <= Zmod 1 2 < 2).
auto with zarith.
assert (1 mod 2 = 0 \/ 1 mod 2 = 1); auto with zarith.
intros; unfold eps.
cut (i/ni = 0).
intros H3; rewrite H3; simpl.
replace (i mod ni) with i; auto.
pattern i at 1; rewrite Z_div_mod_eq with i ni; auto with zarith.
rewrite H3; ring.
assert (i = ni * (i / ni) + i mod ni); auto with zarith.
apply Z_div_mod_eq; auto with zarith.
assert ( i/ni >= 0)%Z.
apply Z_div_ge0; auto with zarith.
assert (i/ni < 1 \/ 1 <= i/ni) by omega.
case H5; auto with zarith.
intros; absurd (ni <= i); auto with zarith.
assert (0 <= i mod ni); auto with zarith. 
generalize (Z_mod_lt i ni); auto with zarith.
rewrite H3; apply Zle_trans with (ni*1+0); auto with zarith.
Qed.

Lemma eps_0: forall  p ni k a mem1 mem2,
     0 < ni ->  
     eps p ni a mem1 mem2 0 k= 0.
intros.
rewrite eps_eps_aux; auto with zarith.
unfold eps_aux1; simpl.
case (Zdichotomy 1 0); auto.
intros; absurd (1 <= 0); auto with zarith.
Qed.


Lemma eps_ni: forall  p ni k a mem1 mem2,
     0 < ni ->  
     eps p ni a mem1 mem2 ni k= 0.
intros.
rewrite eps_eps_aux; auto with zarith.
unfold eps_aux1; simpl.
case (Zdichotomy 1 ni); auto.
case (Zdichotomy ni (ni-1)); auto.
intros; absurd (ni <= ni -1); auto with zarith.
Qed.


Lemma separated_matrix_eps: 
  forall p mem1 mem2 ni a d i1 i2 k1 k2, 
    separated_matrix p (ni+1) mem1 ->
   (0 <= i2 < ni+1) ->  
   (0 <= k1) -> (0 <= k2) ->
   (k1< k2 \/ (k1=k2 /\ 0 <= i1 < i2)) ->
   eps p ni a mem1
      ((store mem2 (shift (select mem1 (shift p i2)) k2) d))
       i1 k1
     = eps p ni a mem1 mem2 i1 k1. 
assert  (forall p mem1 mem2 ni a d i1 i2 k1 k2, 
    separated_matrix p (ni+1) mem1 ->
   (0 <= i2 < ni+1) ->  
   (0 <= k1) -> (0 <= k2) ->
   (k1< k2 \/ (k1=k2 /\ 0 <= i1 < i2)) ->
   eps_aux1 p ni a mem1
      ((store mem2 (shift (select mem1 (shift p i2)) k2) d))
       i1 k1
     = eps_aux1 p ni a mem1 mem2 i1 k1). 
intros.
assert ((i1 <> i2)%Z  \/  (k1<>k2)%Z).
case H3; auto with zarith.
unfold eps_aux1.
case (Zdichotomy 1 i1); auto.
case (Zdichotomy i1 (ni-1)); auto.
case (Zdichotomy k1 0); intros.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) i1 i2 0 k2 d; auto with zarith.
replace 0 with k1; auto with zarith.
case (Zdichotomy k1 1); intros.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) i1 i2 1 k2 d; auto with zarith.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) i1 i2 0 k2 d; auto with zarith.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) (i1+1) i2 0 k2 d; auto with zarith.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) (i1-1) i2 0 k2 d; auto with zarith.
replace 1 with k1; auto with zarith.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) i1 i2 k1 k2 d; auto with zarith.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) i1 i2 (k1-1) k2 d; auto with zarith.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) i1 i2 (k1-2) k2 d; auto with zarith.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) (i1+1) i2 (k1-1) k2 d; auto with zarith.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) (i1-1) i2 (k1-1) k2 d; auto with zarith.
assert (forall p mem1 mem2 ni a d i1 i2 k1 k2, 
    separated_matrix p (ni+1) mem1 ->
   (0 <= i2 < ni+1) ->  
   (0 <= k1) -> (0 <= k2) ->
   (k1< k2 \/ (k1=k2 /\ 0 <= i1 < i2)) ->
   eps_aux2 p ni a mem1
      ((store mem2 (shift (select mem1 (shift p i2)) k2) d))
       i1 k1
     = eps_aux2 p ni a mem1 mem2 i1 k1). 
intros; unfold eps_aux2.
case (Z_eq_dec ((i1 / ni) mod 2) 0).
intros; rewrite H; auto.
case H4; auto.
intros (L1,L2); right; split; auto with zarith.
replace (i1 mod ni) with i1; auto with zarith. 
cut (i1/ni = 0).
intros; pattern i1 at 1; rewrite Z_div_mod_eq with i1 ni; auto with zarith.
rewrite H5; ring.
assert (i1 = ni * (i1 / ni) + i1 mod ni); auto with zarith.
apply Z_div_mod_eq; auto with zarith.
assert ( i1/ni >= 0)%Z.
apply Z_div_ge0; auto with zarith.
assert (i1/ni < 1 \/ 1 <= i1/ni) by omega.
case H7; auto with zarith.
intros; absurd (ni <= i1); auto with zarith.
assert (0 <= i1 mod ni); auto with zarith. 
generalize (Z_mod_lt i1 ni); auto with zarith.
rewrite H5; apply Zle_trans with (ni*1+0); auto with zarith.
intros; rewrite H; auto.
case H4; auto.
intros (L1,L2); right; split; auto with zarith.
absurd ((i1 / ni) mod 2 = 0); auto.
replace (i1/ni) with 0.
unfold Zmod, Zdiv_eucl; auto.
assert (i1 = ni * (i1 / ni) + i1 mod ni); auto with zarith.
apply Z_div_mod_eq; auto with zarith.
assert ( i1/ni >= 0)%Z.
apply Z_div_ge0; auto with zarith.
assert (i1/ni < 1 \/ 1 <= i1/ni) by omega.
case H7; auto with zarith.
intros; absurd (ni <= i1); auto with zarith.
assert (0 <= i1 mod ni); auto with zarith. 
generalize (Z_mod_lt i1 ni); auto with zarith.
rewrite H5; apply Zle_trans with (ni*1+0); auto with zarith.
intros; unfold eps.
generalize (Zcompare_correct 0 i1); case (Zcompare 0 i1).
rewrite H0; auto.
rewrite H0; auto.
case H5; intros.
rewrite H0; auto.
absurd (i1 < 0); auto with zarith.
Qed.

Lemma separated_matrix_scheme: 
  forall p mem1 mem2 ni p0h u1h fh dX i1 k1 i2 k2 d, 
    separated_matrix p (ni+1) mem1 ->
   (fst dX = / (IZR ni)) ->
   (0 <= i1 <= ni) ->  
   (0 <= i2 <= ni) ->  
   (0 <= k1) -> (0 <= k2) ->
   (k1< k2 \/ (k1=k2 /\ i1 < i2)) ->
 
  scheme 0 1 c p0h u1h fh (fun _ i j => double_exact 
     (select  (store mem2 (shift (select mem1 (shift p i2)) k2) d)
               (shift (select mem1 (shift p i)) j))) dX i1 (Zabs_nat k1) =
   scheme 0 1 c p0h u1h fh (fun _ i j => double_exact 
     (select mem2 (shift (select mem1 (shift p i)) j))) dX i1 (Zabs_nat k1).
intros.
unfold scheme.
case (Z_lt_le_dec 0 i1); intros V.
case (Z_lt_le_dec i1 (R_n.ni 0 1 (fst dX))); intros V'.
case (Z_lt_le_dec i1 ni); intros V''.
cut (k1=Zabs_nat k1).
case (Zabs_nat k1); intros.
unfold Lh; simpl.
apply f_equal2;[apply f_equal|auto].
apply separated_matrix_prop with (ni+1); auto with zarith.
case H5; auto with zarith.
generalize H6; clear H6; case n; intros.
unfold Lh; simpl.
apply Rplus_eq_compat_r.
apply Rplus_eq_compat.
apply f_equal2; auto.
unfold Rminus; apply Rplus_eq_compat.
apply f_equal.
apply separated_matrix_prop with (ni+1); auto with zarith.
simpl in H6; case H5; auto with zarith.
apply f_equal; apply f_equal.
apply separated_matrix_prop with (ni+1); auto with zarith.
simpl in H6; case H5; auto with zarith.
apply f_equal.
unfold Ah; simpl in H6.
repeat apply f_equal2; auto; apply f_equal;
  apply separated_matrix_prop with (ni+1); auto with zarith.
assert (2 <= k1)%Z.
rewrite H6, inj_S,inj_S; auto with zarith.
apply f_equal2; auto.
unfold Lh.
repeat apply f_equal2; auto.
apply f_equal; apply separated_matrix_prop with (ni+1); auto with zarith.
replace (Z_of_nat (n0+2)) with k1; auto with zarith.
case H5; auto with zarith.
rewrite H6; auto with arith zarith.
apply f_equal; apply separated_matrix_prop with (ni+1); auto with zarith.
replace (Z_of_nat (n0+1)) with (k1-1); auto with zarith.
rewrite H6; auto with arith zarith.
rewrite inj_S; unfold Zsucc; ring_simplify; auto with zarith.
apply f_equal; apply separated_matrix_prop with (ni+1); auto with zarith.
replace (Z_of_nat n0) with (k1-2); auto with zarith.
rewrite H6; auto with arith zarith.
rewrite 2!inj_S; unfold Zsucc; ring_simplify; auto with zarith.
unfold Ah.
repeat apply f_equal2; auto; apply f_equal;
  apply separated_matrix_prop with (ni+1); auto with zarith.
replace (Z_of_nat (n0+1)) with (k1-1); auto with zarith.
rewrite H6; auto with arith zarith.
rewrite inj_S; unfold Zsucc; ring_simplify; auto with zarith.
replace (Z_of_nat (n0+1)) with (k1-1); auto with zarith.
rewrite H6; auto with arith zarith.
rewrite inj_S; unfold Zsucc; ring_simplify; auto with zarith.
replace (Z_of_nat (n0+1)) with (k1-1); auto with zarith.
rewrite H6; auto with arith zarith.
rewrite inj_S; unfold Zsucc; ring_simplify; auto with zarith.
rewrite <- Zabs_absolu; auto with zarith.
rewrite Zabs_eq; auto with zarith.
absurd (ni = R_n.ni 0 1 (fst dX)); auto with zarith.
unfold R_n.ni, jx.
replace ((1 - 0) / fst dX)%R with (IZR ni).
apply sym_eq; apply Int_part_IZR.
rewrite H0; field.
auto with real zarith.
apply f_equal; apply separated_matrix_prop with (ni+1); auto with zarith.
rewrite <- Zabs_absolu; auto with zarith.
rewrite Zabs_eq; auto with zarith.
case H5; auto with zarith.
apply f_equal; apply separated_matrix_prop with (ni+1); auto with zarith.
rewrite <- Zabs_absolu; auto with zarith.
rewrite Zabs_eq; auto with zarith.
case H5; auto with zarith.
Qed.


Lemma eps_sym1: forall  p ni i k a mem1 mem2,
    (0 < ni) ->
    (eps p ni a mem1 mem2 (-i) k = - eps p ni a mem1 mem2 i k)%R.
intros; unfold eps.
generalize (Zcompare_correct 0 i); case (Zcompare 0 i).
intros H1; rewrite <- H1; simpl.
apply trans_eq with (eps p ni a mem1 mem2 0 k).
unfold eps; simpl; auto.
rewrite eps_0; auto.
apply trans_eq with (-(eps p ni a mem1 mem2 0 k))%R.
rewrite eps_0; auto with real.
unfold eps; simpl; auto.
generalize (Zcompare_correct 0 (-i)); case (Zcompare 0 (-i)).
intros; absurd (0 < i); auto with zarith.
intros; absurd (0 < i); auto with zarith.
ring_simplify (-(-i)); auto.
generalize (Zcompare_correct 0 (-i)); case (Zcompare 0 (-i)).
intros; absurd (i < 0); auto with zarith.
intros; ring.
intros; absurd (i < 0); auto with zarith.
Qed.


Lemma eps_sym2: forall p ni i k a mem1 mem2,
    (0 < ni) ->
    (eps p ni a mem1 mem2 (ni-i) k = - eps p ni a mem1 mem2 (ni+i) k)%R.
intros.
assert (forall  p ni i k a mem1 mem2,
    (0 < ni) -> (0 < i < ni) ->
    (eps_aux2 p ni a mem1 mem2 (ni-i) k = - eps_aux2 p ni a mem1 mem2 (ni+i) k)%R).
intros; unfold eps_aux2.
replace ((ni0 - i0) / ni0) with 0.
replace (0 mod 2) with 0; simpl.
replace ((ni0 + i0) / ni0) with 1.
replace (1 mod 2) with 1; simpl.
replace ((ni0 - (ni0 + i0)) mod ni0) with ((ni0 - i0) mod ni0).
ring.
replace (ni0 - (ni0 + i0)) with ((ni0-i0)+ (-1)*ni0) by ring.
rewrite Z_mod_plus; auto with zarith.
unfold Zmod; simpl; auto.
replace (ni0+i0) with (i0+1*ni0) by ring.
rewrite Z_div_plus; auto with zarith.
replace (i0/ni0) with 0; auto with zarith.
assert (i0 = ni0* (i0 / ni0) + i0 mod ni0); auto with zarith.
apply Z_div_mod_eq; auto with zarith.
assert ( i0/ni0 >= 0)%Z.
apply Z_div_ge0; auto with zarith.
assert (i0/ni0 < 1 \/ 1 <= i0/ni0) by omega.
case H4; auto with zarith.
intros; absurd (ni0 <= i0); auto with zarith.
assert (0 <= i0 mod ni0); auto with zarith. 
generalize (Z_mod_lt i0 ni0); auto with zarith.
rewrite H2; apply Zle_trans with (ni0*1+0); auto with zarith.
simpl; auto.
assert (ni0 -i0= ni0* ((ni0-i0) / ni0) + (ni0-i0) mod ni0); auto with zarith.
apply Z_div_mod_eq; auto with zarith.
assert ( (ni0-i0)/ni0 >= 0)%Z.
apply Z_div_ge0; auto with zarith.
assert ((ni0-i0)/ni0 < 1 \/ 1 <= (ni0-i0)/ni0) by omega.
case H4; auto with zarith.
intros; absurd (ni0 <= ni0-i0); auto with zarith.
assert (0 <= (ni0-i0) mod ni0); auto with zarith. 
generalize (Z_mod_lt (ni0-i0) ni0); auto with zarith.
rewrite H2; apply Zle_trans with (ni0*1+0); auto with zarith.
assert (forall p ni k a mem1 mem2,
     0 < ni ->
     eps_aux2 p ni a mem1 mem2 (ni - 0) k=
     (- eps_aux2 p ni a mem1 mem2 (ni + 0) k)%R).
intros; ring_simplify (ni0-0); ring_simplify (ni0+0).
apply trans_eq with (eps p1 ni0 a0 mem0 mem3 ni0 k0).
unfold eps.
generalize (Zcompare_correct 0 ni0); case (Zcompare 0 ni0); auto with zarith.
intros; absurd (0 < ni0); auto with zarith.
rewrite eps_ni; auto with zarith.
apply trans_eq with (- eps p1 ni0 a0 mem0 mem3 ni0 k0)%R.
rewrite eps_ni; auto with zarith real.
unfold eps.
generalize (Zcompare_correct 0 ni0); case (Zcompare 0 ni0); auto with zarith.
intros; absurd (0 < ni0); auto with zarith.
assert (forall p ni k a mem1 mem2,
     0 < ni ->
     eps_aux2 p ni a mem1 mem2 (ni - ni) k=
     (- eps_aux2 p ni a mem1 mem2 (ni + ni) k)%R).
intros; ring_simplify (ni0-ni0).
apply trans_eq with (eps p1 ni0 a0 mem0 mem3 0 k0).
unfold eps; simpl; auto.
rewrite eps_0; auto with zarith.
unfold eps_aux2.
replace (ni0+ni0) with (2*ni0) by ring.
rewrite Z_div_mult; auto with zarith.
replace (2 mod 2) with 0.
2: unfold Zmod; simpl; auto.
apply trans_eq with 
  (-(eps_aux1 p1 ni0 a0 mem0 mem3 ((2 * ni0) mod ni0) k0))%R; auto.
rewrite Z_div_exact_1; auto with zarith.
apply trans_eq with (- eps p1 ni0 a0 mem0 mem3 0 k0)%R.
rewrite eps_0; auto with real.
unfold eps; simpl; auto.
rewrite Z_div_mult; auto with zarith.
assert (forall p ni i k a mem1 mem2,
     0 < ni ->
     0 <= i <= ni ->
     eps_aux2 p ni a mem1 mem2 (ni - i) k=
     (- eps_aux2 p ni a mem1 mem2 (ni + i) k)%R).
intros.
assert (i0=0 \/ 0 < i0 < ni0 \/ i0=ni0); auto with zarith.
case (Zle_lt_or_eq 0 i0); auto with zarith.
intros; case (Zle_lt_or_eq  i0 ni0); auto with zarith.
case H5.
intros N; rewrite N; apply H1; auto.
clear H5; intros H5; case H5.
intros; apply H0; auto.
intros N; rewrite N; apply H2; auto.
clear H0 H1 H2.
unfold eps.
generalize (Zcompare_correct 0 (ni-i)); case (Zcompare 0 (ni - i)).
intros; assert (0 < ni+i); auto with zarith.
generalize (Zcompare_correct 0 (ni+i)); case (Zcompare 0 (ni + i)).
intros; absurd (0 < ni + i); auto with zarith.
2: intros; absurd (0 < ni + i); auto with zarith.
intros; apply H3; auto with zarith.
generalize (Zcompare_correct 0 (ni+i)); case (Zcompare 0 (ni + i)).
intros; replace (ni+i) with (ni-(-i)) by ring.
replace (ni-i) with (ni+(-i)) by ring.
rewrite H3; auto with zarith real.
case (Zle_or_lt 0 i); intros.
apply H3; auto with zarith.
replace (ni+i) with (ni-(-i)) by ring.
replace (ni-i) with (ni+(-i)) by ring.
rewrite H3; auto with zarith real.
intros; unfold eps_aux2.
replace (((ni - i) / ni) mod 2) with ((- (ni + i) / ni) mod 2).
case (Z_eq_dec ((- (ni + i) / ni) mod 2) 0); intros.
replace ((ni - i) mod ni) with (- (ni + i) mod ni); auto with real.
replace (-(ni+i)) with (-i+(-1)*ni) by ring.
rewrite Z_mod_plus; auto with zarith.
replace (ni-i) with (-i+1*ni) by ring.
rewrite Z_mod_plus; auto with zarith.
replace  ((ni - (ni - i)) mod ni) with ((ni - - (ni + i)) mod ni); auto with real.
replace  (ni - - (ni + i)) with (i+2*ni) by ring.
rewrite Z_mod_plus; auto with zarith.
replace (ni-(ni-i)) with i by ring; auto.
replace (- (ni + i) ) with (((ni-i)+(-2)*ni)) by ring.
rewrite Z_div_plus; auto with zarith.
replace (-2) with ((-1)*2) by ring.
rewrite Z_mod_plus; auto with zarith.
intros; assert  (0 < ni + i); auto with zarith.
generalize (Zcompare_correct 0 (ni+i)); case (Zcompare 0 (ni + i)).
intros; absurd  (0 < ni + i); auto with zarith.
2: intros; absurd  (0 < ni + i); auto with zarith.
intros; unfold eps_aux2.
replace ((-(ni - i) / ni) mod 2) with (((ni + i) / ni) mod 2).
case (Z_eq_dec (( (ni + i) / ni) mod 2) 0); intros.
replace (-(ni - i) mod ni) with ( (ni + i) mod ni); auto with real.
replace (-(ni-i)) with (i+(-1)*ni) by ring.
rewrite Z_mod_plus; auto with zarith.
replace (ni+i) with (i+1*ni) by ring.
rewrite Z_mod_plus; auto with zarith.
replace  ((ni - (ni + i)) mod ni) with ((ni - - (ni - i)) mod ni); auto with real.
replace  (ni - - (ni - i)) with (-i+2*ni) by ring.
rewrite Z_mod_plus; auto with zarith.
replace (ni-(ni+i)) with (-i) by ring; auto.
replace (- (ni - i) ) with (((ni+i)+(-2)*ni)) by ring.
rewrite Z_div_plus; auto with zarith.
replace (-2) with ((-1)*2) by ring.
rewrite Z_mod_plus; auto with zarith.
Qed.



Lemma Err_0_sym: forall p ni i k a mem1 mem2,
     (0 <= k) -> (0 < ni) ->
    (Err (double_exact a) (eps p ni a mem1 mem2) i k = 
     -Err (double_exact a) (eps p ni a mem1 mem2) (-i) k)%R.
intros; unfold Err.
apply sym_eq.
apply trans_eq with 
 ((-1)*
 sum_f_z
   (fun l : Z =>
    sum_f_z
      (fun j : Z =>
       alpha (double_exact a) j (Zabs_nat l) *
       eps p ni a mem1 mem2 (- i + j) (k - l)) (- l) l) 0 k)%R.
ring.
rewrite <- sum_f_z_mult; auto.
apply sum_f_z_eq; auto.
intros; rewrite <- sum_f_z_mult; auto with zarith.
rewrite sum_f_z_switch; auto with zarith.
replace (-(-k0))%Z with k0; auto with zarith.
apply sum_f_z_eq; auto with zarith.
intros.
rewrite <- alpha_sym.
replace (eps p ni a mem1 mem2 (- i + - k1) (k - k0)) with
   (-(eps p ni a mem1 mem2 (i + k1) (k - k0)))%R.
ring.
replace (-i+-k1)%Z with (-(i+k1))%Z by ring.
rewrite eps_sym1; auto with zarith.
Qed.


Lemma Err_ni_sym: forall  p ni i k a mem1 mem2,
     (0 <= k) -> (0 < ni) ->
    (Err (double_exact a) (eps p ni a mem1 mem2) (ni-i) k = 
     -Err (double_exact a) (eps p ni a mem1 mem2) (ni+i) k)%R.
intros; unfold Err.
apply sym_eq.
apply trans_eq with 
 ((-1)*
 sum_f_z
   (fun l : Z =>
    sum_f_z
      (fun j : Z =>
       alpha (double_exact a) j (Zabs_nat l) *
       eps p ni a mem1 mem2 (ni+ i + j) (k - l)) (- l) l) 0 k)%R.
ring.
rewrite <- sum_f_z_mult; auto.
apply sum_f_z_eq; auto.
intros; rewrite <- sum_f_z_mult; auto with zarith.
rewrite sum_f_z_switch; auto with zarith.
replace (-(-k0))%Z with k0; auto with zarith.
apply sum_f_z_eq; auto with zarith.
intros.
rewrite <- alpha_sym.
replace (eps p ni a mem1 mem2 (ni+ i + - k1) (k - k0)) with
   (-(eps p ni a mem1 mem2 (ni-i + k1) (k - k0)))%R.
ring.
replace (ni-i+k1)%Z with (ni-(i-k1))%Z by ring.
replace (ni+i+-k1)%Z with (ni+(i-k1))%Z by ring.
rewrite eps_sym2; auto with zarith real.
Qed.




Lemma Err_0_aux: forall  p ni (k:nat) a mem1 mem2,
    (0 < ni) -> (0 < double_exact a)%R ->
    (Err (double_exact a) (eps p ni a mem1 mem2) 0 k = 0)%R.
intros; pattern k; apply lt_wf_ind.
intros n; case n;intros.
unfold Err; repeat rewrite sum_f_z_1.
rewrite eps_0; auto with zarith.
simpl; ring.
generalize H1; case n0.
clear H1; intros H1.
simpl; unfold Err.
rewrite sum_f_z_down; auto with zarith.
repeat rewrite sum_f_z_1; repeat rewrite eps_0; auto with zarith.
ring_simplify (1-1).
rewrite sum_f_z_down; auto with zarith.
rewrite sum_f_z_up; auto with zarith.
rewrite sum_f_z_1.
ring_simplify (1-1); ring_simplify (0+-(1)); ring_simplify (0+1).
replace (-1) with (-(1)); auto with zarith.
rewrite eps_sym1; auto.
rewrite eps_0; auto.
simpl; ring.
intros.
replace (Z_of_nat (S (S n1))) with (S n1+1); auto with zarith.
rewrite alpha_err_ok_nat; auto with zarith.
rewrite eps_0; auto with zarith.
rewrite Err_0_sym; auto with zarith.
ring_simplify (-(0+1)); ring_simplify (0-1).
rewrite H2 with (S n1); auto with zarith.
replace (S n1 -1)%Z with (Z_of_nat n1); auto with zarith.
rewrite H2; auto with zarith.
simpl (IZR 0);ring.
rewrite inj_S; auto with zarith.
repeat rewrite inj_S; auto with zarith.
Qed.


Lemma Err_0:  forall  p ni k a mem1 mem2,
    (0 < ni) -> (0 < double_exact a)%R -> (0 <= k) ->
    (Err (double_exact a) (eps p ni a mem1 mem2) 0 k = 0)%R.
intros.
assert (k=Zabs_nat k).
rewrite inj_abs; auto with zarith.
rewrite H2; apply Err_0_aux; auto.
Qed.


Lemma Err_ni_aux: forall p ni (k:nat) a mem1 mem2,
    (0 < ni) -> (0 < double_exact a)%R ->
    (Err (double_exact a) (eps p ni a mem1 mem2) ni k = 0)%R.
intros; pattern k; apply lt_wf_ind.
intros n; case n;intros.
unfold Err; repeat rewrite sum_f_z_1.
replace (ni+0%nat) with ni; auto with zarith.
rewrite eps_ni; auto with zarith.
simpl; ring.
generalize H1; case n0.
clear H1; intros H1.
simpl; unfold Err.
rewrite sum_f_z_down; auto with zarith.
repeat rewrite sum_f_z_1; repeat rewrite eps_0; auto with zarith.
ring_simplify (1-1).
rewrite sum_f_z_down; auto with zarith.
rewrite sum_f_z_up; auto with zarith.
rewrite sum_f_z_1.
ring_simplify (1-1); ring_simplify (ni+0).
replace (ni + - (1)) with (ni-1) by ring.
rewrite eps_sym2; auto.
rewrite eps_ni; auto.
rewrite eps_ni; auto.
simpl; ring.
intros.
replace (Z_of_nat (S (S n1))) with (S n1+1); auto with zarith.
rewrite alpha_err_ok_nat; auto with zarith.
rewrite eps_ni; auto with zarith.
rewrite Err_ni_sym; auto with zarith.
rewrite H2 with (S n1); auto with zarith.
replace (S n1 -1)%Z with (Z_of_nat n1); auto with zarith.
rewrite H2; auto with zarith.
simpl (IZR 0);ring.
rewrite inj_S; auto with zarith.
repeat rewrite inj_S; auto with zarith.
Qed.


Lemma Err_ni: forall p ni k a mem1 mem2,
    (0 < ni) -> (0 < double_exact a)%R -> (0 <= k) ->
    (Err (double_exact a) (eps p ni a mem1 mem2) ni k = 0)%R.
intros.
assert (k=Zabs_nat k).
rewrite inj_abs; auto with zarith.
rewrite H2; apply Err_ni_aux; auto.
Qed.




Lemma analytic_error_implies_error: forall p ni i k a dt mem1 mem2,
    (analytic_error p ni i k a dt mem1 mem2) -> 
     (0 <= i <= ni)%Z -> (0 <= k)%Z ->
     (double_round_error (select mem2 (shift (select mem1 (shift p i)) k))
       <= 78*powerRZ 2 (-52)*((k+1)*(k+2)/2))%R.
intros; generalize H1; clear H1; intros H1'.
elim H; auto with zarith;intros HH1 (HH2,(H1,(H2,_))).
unfold double_round_error.
replace  (double_value (select mem2 (shift (select mem1 (shift p i)) k)) -
    double_exact (select mem2 (shift (select mem1 (shift p i)) k)))%R with
    (-(double_exact (select mem2 (shift (select mem1 (shift p i)) k)) -
     double_value (select mem2 (shift (select mem1 (shift p i)) k))))%R by ring.
rewrite Rabs_Ropp.
rewrite (H2 i k); auto with zarith; clear H2 HH1 HH2; unfold Err.
apply Rle_trans with (sum_f_z
      (fun l : Z =>
       (Rabs ((sum_f_z
         (fun j : Z =>
          alpha (double_exact a) j (Zabs_nat l) * eps p ni a mem1 mem2 (i + j)%Z (k - l)%Z))
         (- l)%Z l))) 0 k)%R.
apply sum_f_z_Rabs; auto with zarith.
apply Rle_trans with (sum_f_z
   (fun l : Z =>
      (sum_f_z
         (fun j : Z =>
          Rabs (alpha (double_exact a) j (Zabs_nat l) * eps p ni a mem1 mem2 (i + j)%Z (k - l)%Z))
         (- l) l)) 0 k)%R.
apply sum_f_z_le; auto with zarith.
intros; apply sum_f_z_Rabs; auto with zarith.
apply Rle_trans with (sum_f_z
   (fun l : Z =>
    sum_f_z
      (fun j : Z =>
       (78*powerRZ 2 (-52) * Rabs (alpha (double_exact a) j (Zabs_nat l))))
      (- l) l) 0 k)%R.
apply sum_f_z_le; auto with zarith.
intros; apply sum_f_z_le; auto with zarith.
intros; rewrite Rabs_mult.
rewrite Rmult_comm; apply Rmult_le_compat_r; auto with real.
apply H1; auto with zarith.
case (Zle_lt_or_eq 0 k0); auto with zarith.
apply Rle_trans with ((78 * powerRZ 2 (-52)) * sum_f_z
   (fun l : Z =>
     sum_f_z
      (fun j : Z =>
        Rabs (alpha (double_exact a) j (Zabs_nat l))) 
      (- l) l) 0 k)%R.
right.
rewrite <- sum_f_z_mult; auto with zarith.
apply sum_f_z_eq; auto with zarith; intros.
rewrite sum_f_z_mult; auto with zarith; auto.
apply Rmult_le_compat_l; auto with real zarith.
apply Rmult_le_pos; auto with real zarith.
apply Rle_trans with (INR 78); auto with real zarith.
simpl; right; ring.
apply Rle_trans with (sum_f_z
   (fun l : Z =>
    sum_f_z (fun j : Z => alpha (double_exact a) j (Zabs_nat l)) (- l) l) 0
   k ).
right; apply sum_f_z_eq; auto with zarith.
intros; apply sum_f_z_eq; auto with zarith.
intros; rewrite Rabs_right; auto.
apply Rle_ge; apply alpha.alpha_pos; auto.
apply Rle_trans with (sum_f_z (fun l => l+1) 0 k).
right; apply sum_f_z_eq; auto with zarith; intros.
pattern k0 at 2 3.
replace k0 with (Z_of_nat (Zabs_nat k0)).
rewrite alpha_sum.
rewrite INR_IZR_INZ.
rewrite <- Zabs_absolu; rewrite Zabs_eq; auto with real zarith.
rewrite plus_IZR; auto.
rewrite <- Zabs_absolu; rewrite Zabs_eq; auto with real zarith.
assert (forall n:nat, 
  (sum_f_z (fun l : Z => (l + 1)%Z) 0 n = (n + 1) * (n + 2) / 2)%R).
intros n; induction n.
rewrite sum_f_z_1.
simpl; field; auto with real.
rewrite sum_f_z_up; auto with zarith.
replace (S n -1)%Z with (Z_of_nat n); auto with zarith.
rewrite IHn.
rewrite plus_IZR; rewrite <- INR_IZR_INZ.
replace (INR (S n)) with (INR n +1)%R.
simpl;field.
case n; auto with real zarith.
rewrite inj_S; unfold Zsucc; ring.
replace k with (Z_of_nat (Zabs_nat k)).
repeat rewrite <- INR_IZR_INZ.
right; apply H2.
rewrite <- Zabs_absolu; rewrite Zabs_eq; auto with zarith.
Qed.


Lemma analytic_error_implies_error1: forall p ni i1 k1 i k a dt mem1 mem2,
    (analytic_error p ni i1 k1 a dt mem1 mem2) -> 
     (0 <= i  <= ni)%Z -> (0 <= k)%Z ->
     (0 <= i1 <= ni)%Z -> (0 <= k1)%Z ->    
     (k < k1 \/ (k=k1 /\ i <= i1)) ->
     (double_round_error (select mem2 (shift (select mem1 (shift p i)) k))
       <= 78*powerRZ 2 (-52)*((k+1)*(k+2)/2))%R.
intros.
apply analytic_error_implies_error with ni a dt; auto.
elim H; auto with zarith; intros Y1 (Y2,(Y3,(Y4,Y5))).
case H4; intros.
split.
intros; apply Y2; auto with zarith.
split.
intros; apply Y2; auto with zarith.
split.
intros; apply Y3; auto with zarith.
split.
intros; apply Y4; auto with zarith.
intros; apply Y5; auto with zarith.
destruct H5.
split.
intros; apply Y1; auto with zarith.
split.
intros; apply Y2; auto with zarith.
split.
intros; apply Y3; auto with zarith.
rewrite <- H5; case H9; auto with zarith.
split.
intros; apply Y4; auto with zarith.
rewrite <- H5; case H10; auto with zarith.
intros; apply Y5; auto with zarith.
rewrite <- H5; case H10; auto with zarith.
Qed.



Lemma analytic_error_0_0: forall p ni a dt mem1 mem2 mem3 d,
     (* separated_matrix p (ni+1) mem1 ->*) (0 < ni) ->
     (0 < double_exact a)%R ->
     (mem3=store mem2 (shift (select mem1 (shift p 0)) 0) d) -> 
     double_value d  = 0 ->
     double_exact d  = 0 -> 
     (analytic_error p ni 0 0 a dt mem1 mem3).
intros p ni a dt mem1 mem2 mem3 d H1 H0 H2 H3 H4.
split.
intros.
replace i1 with 0%Z; auto with zarith. 
rewrite eps_0; auto with zarith.
simpl (IZR 0); rewrite Rabs_R0; apply Rmult_le_pos; auto with real zarith.
apply Rle_trans with (INR 14); auto with real zarith.
right; simpl; ring.
split; intros.
absurd (0 < 0)%Z; auto with zarith.
split; intros.
replace k1 with 0%Z; auto with zarith.
replace i1 with 0%Z; auto with zarith.
rewrite eps_0; auto with zarith.
simpl (IZR 0); rewrite Rabs_R0; apply Rmult_le_pos; auto with real zarith.
apply Rle_trans with (INR 78); auto with real zarith.
right; simpl; ring.
split; intros.
replace i1 with 0; auto with zarith.
rewrite Err_0; auto with zarith.
replace k1 with 0; auto with zarith.
replace (select mem3 (shift (select mem1 (shift p 0)) 0))
 with d.
rewrite H3,H4; ring.
rewrite H2.
apply sym_eq; apply select_store_eq; auto.
replace i1 with 0; auto with zarith.
replace k1 with 0; auto with zarith.
unfold scheme.
case (Z_lt_le_dec 0 0).
intros V; contradict V; auto with zarith.
intros _.
simpl.
replace (select mem3 (shift (select mem1 (shift p 0)) 0))
 with d; auto.
rewrite H2.
apply sym_eq; apply select_store_eq; auto.
Qed.



Lemma analytic_error_0: forall p ni a dt i mem1 mem2 mem3 d,
     separated_matrix p (ni+1) mem1 -> 
     (0 < i < ni)%Z ->
     (analytic_error p ni (i-1) 0 a dt mem1 mem2) -> 
     (mem3=store mem2 (shift (select mem1 (shift p i)) 0) d) -> 
     (double_round_error d  <= 14 * powerRZ radix (-52))%R -> 
     double_exact d  = p0 (IZR i/ni)%R ->
     (analytic_error p ni i 0 a dt mem1 mem3).
intros p ni a dt i mem1 mem2 mem3 d Hsep Hi Hrec Hmem Hd Hde.
split; intros.
case (Zle_lt_or_eq i1 i); auto with zarith.
intros; rewrite Hmem.
rewrite separated_matrix_eps; auto with zarith.
unfold analytic_error in Hrec.
assert (0 <= i-1)%Z.
auto with zarith.
apply (proj1 (Hrec H4 H0)); auto with zarith.
intros H3; rewrite H3.
apply Rle_trans with (2:=Hd).
unfold double_round_error; rewrite <- Rabs_Ropp; right; apply f_equal.
rewrite eps_eps_aux; auto with zarith.
unfold eps_aux1.
case (Zdichotomy 1 i).
case (Zdichotomy i (ni - 1)).
case (Zdichotomy 0 0).
replace  (select mem3 (shift (select mem1 (shift p i)) 0))
   with d.
intros; ring.
rewrite Hmem.
apply sym_eq; apply select_store_eq; auto.
intros V; contradict V; auto with zarith.
intros V; contradict V; auto with zarith.
intros V; contradict V; auto with zarith.
split.
intros V; contradict V; auto with zarith.
split.
intros.
assert (k1=0)%Z; auto with zarith.
rewrite H2.
case (Zle_lt_or_eq i1 i); auto with zarith.
intros; rewrite Hmem.
rewrite separated_matrix_eps; auto with zarith.
unfold analytic_error in Hrec.
assert (0 <= i-1)%Z.
auto with zarith.
apply Rle_trans with (14 *  powerRZ 2 (-52))%R.
apply (proj1 (Hrec H4 H0)); auto with zarith.
apply Rmult_le_compat_r; auto with real.
apply Rle_trans with (IZR 14); auto with real zarith.
right; simpl; ring.
apply Rle_trans with (IZR 78); auto with real zarith.
right; simpl; ring.
intros H3; rewrite H3.
apply Rle_trans with (14 * powerRZ radix (-52))%R.
apply Rle_trans with (2:=Hd).
unfold double_round_error; rewrite <- Rabs_Ropp; right; apply f_equal.
rewrite eps_eps_aux; auto with zarith.
unfold eps_aux1.
case (Zdichotomy 1 i).
case (Zdichotomy i (ni - 1)).
case (Zdichotomy 0 0).
replace  (select mem3 (shift (select mem1 (shift p i)) 0))
   with d.
intros; ring.
rewrite Hmem.
apply sym_eq; apply select_store_eq; auto.
intros V; contradict V; auto with zarith.
intros V; contradict V; auto with zarith.
intros V; contradict V; auto with zarith.
apply Rmult_le_compat_r; auto with real zarith.
apply Rle_trans with (IZR 14); auto with real zarith.
right; simpl; ring.
apply Rle_trans with (IZR 78); auto with real zarith.
right; simpl; ring.
split.
intros.
assert (k1=0)%Z; auto with zarith.
rewrite H3.
unfold Err; rewrite sum_f_z_1.
rewrite sum_f_z_1; simpl.
ring_simplify (i1+0).
rewrite eps_eps_aux; auto with zarith.
unfold eps_aux1.
case (Zdichotomy 1 i1).
case (Zdichotomy i1 (ni - 1)).
case (Zdichotomy 0 0).
intros; auto with real.
intros; absurd (0<0); auto with zarith.
intros; absurd (i1 < ni); auto with zarith.
intros; assert (i1=0); auto with zarith.
rewrite H4.
replace (select mem3 (shift (select mem1 (shift p 0)) 0))
  with  (select mem2 (shift (select mem1 (shift p 0)) 0)).
unfold analytic_error in Hrec.
assert (0 <= i-1) by auto with zarith.
destruct (Hrec H5 H0) as (_, (_,(_,(Y1,Y2)))).
rewrite Y1; auto with zarith.
unfold Err; rewrite sum_f_z_1; rewrite sum_f_z_1; simpl.
rewrite eps_eps_aux; auto with zarith.
unfold eps_aux1.
case (Zdichotomy 1 0); auto.
intros; absurd (1 <=0); auto with zarith.
rewrite Hmem.
rewrite <- separated_matrix_prop with p mem1 
  mem2 (ni+1) 0 i 0 0 d; auto with zarith.
intros.
assert (k1=0)%Z; auto with zarith.
case (Zle_lt_or_eq i1 i); auto with zarith.
unfold analytic_error in Hrec.
assert (0 <= i-1) by auto with zarith.
destruct (Hrec H4 H0) as (_, (_,(_,(Y1,Y2)))).
intros; apply sym_eq; rewrite <- (Y2 i1 0) at 1; auto with zarith.
rewrite Hmem,H3.
apply sym_eq.
apply separated_matrix_scheme with (ni); auto with zarith.
intros H4; rewrite H3,H4.
unfold scheme; simpl.
case (Z_lt_le_dec 0 i).
case (Z_lt_le_dec i (R_n.ni 0 1 (/ ni))).
intros.
replace (select mem3 (shift (select mem1 (shift p i)) 0)) with d.
rewrite Hde.
apply Rminus_diag_eq.
unfold p0h; simpl.
apply f_equal; unfold Rdiv; ring.
rewrite Hmem.
apply sym_eq; apply select_store_eq; auto.
intros V; contradict V.
replace (R_n.ni 0 1 (/ ni)) with ni; auto with zarith.
unfold R_n.ni, jx.
replace ((1 - 0) / / ni)%R with (IZR ni).
apply sym_eq; apply Int_part_IZR.
field; auto with zarith real.
intros V; contradict V; auto with zarith.
Qed.





Lemma analytic_error_plusi : forall p ni i k a dt mem1 mem2 mem3 d r,
    separated_matrix p (ni+1) mem1 -> 
      (0 <= i < ni)%Z -> (0 < k)%Z ->
    (analytic_error p ni i k a dt mem1 mem2) -> 
     (mem3=store mem2 (shift (select mem1 (shift p (i+1))) k) d) ->
     (r = eps p ni a mem1 mem3 (i+1)%Z k) -> 
     (Rabs r <= 78*powerRZ 2 (-52))%R ->
     (double_exact d - double_value d = r+
      (sum_f_z 
         (fun l => sum_f_z 
                  (fun j => (alpha (double_exact a) j (Zabs_nat l))
                                  * (eps p ni a mem1 mem2 (i+1+j)%Z (k-l)%Z))
          (-l) l)
    1 k))%R ->
    scheme 0 1 c p0h (fun (_ : R * R) (_ : Z) => Z0) 
      (fun (_ : R * R) (_ : Z) (_ : nat) => Z0)
      (fun (_ : R * R) (l1 : Z) (l2 : nat) =>
      double_exact (select mem3 (shift (select mem1 (shift p l1)) l2)))
      (/(IZR ni), double_exact dt) (i+1) (Zabs_nat k) = Z0

   ->
   (analytic_error p ni (i+1) k a dt mem1 mem3).
intros p ni i k a dt mem1 mem2 mem3 d r; intros H H0 H1 H2 H3 H4 H5 H6 S.
unfold analytic_error in H2 |-*.
elim H2; auto with zarith; intros N1 (N2,(H11,(H12,K))).
intros; split; intros.
absurd (k=0)%Z; auto with zarith.
intros; split.
intros; rewrite H3; rewrite separated_matrix_eps; auto with zarith.
split; intros.
assert ((0 <= k1 < k \/ k1 = k /\ 0 <= i1 <= i) \/ (k1=k /\ i1=i+1)) by omega.
case H10; intros.
rewrite H3; rewrite separated_matrix_eps; auto with zarith.
clear -H13; case H13; auto with zarith.
elim H13; intros L1 L2; rewrite L1; rewrite L2; rewrite <- H4; auto.
split; intros.
assert ((0 <= k1 < k \/ k1 = k /\ 0 <= i1 <= i) \/ (k1=k /\ i1=i+1)) by omega.
case H13; intros.
rewrite H3.
rewrite separated_matrix_prop with p mem1 mem2 (ni+1) i1 (i+1) k1 k d; auto with zarith.
2: clear -H14; case H14; auto with zarith.
rewrite H12; auto with zarith.
2: clear -H14; case H14; auto with zarith.
unfold Err; apply sum_f_z_eq; auto with zarith.
intros; apply sum_f_z_eq; auto with zarith.
intros j; intros.
rewrite separated_matrix_eps; auto with zarith.
case H14; auto with zarith.
intros (L1,L2); case (Zle_lt_or_eq 0 k0); auto with zarith.
elim H14; intros L1 L2; rewrite L1; rewrite L2.
replace (select mem3 (shift (select mem1 (shift p (i + 1))) k)) with d.
rewrite H6; unfold Err.
rewrite sum_f_z_down with (i:=0); auto with zarith.
apply Rplus_eq_compat.
rewrite H4; rewrite sum_f_z_1;simpl.
replace (i+1+0) with (i+1); auto with zarith real.
replace (k-0) with k; auto with zarith real.
apply sum_f_z_eq; auto with zarith.
intros; apply sum_f_z_eq; auto with zarith.
intros j; intros; rewrite H3.
rewrite separated_matrix_eps; auto with zarith.
rewrite H3.
now rewrite select_store_eq.
assert ((0 <= k1 < k \/ k1 = k /\ 0 <= i1 <= i) \/ (k1=k /\ i1=i+1)) by omega.
case H13; intros.
rewrite H3.
apply sym_eq; rewrite <- (K i1 k1) at 1; auto with zarith.
apply sym_eq; apply separated_matrix_scheme with ni; auto with zarith.
case H14; auto with zarith.
case H14; auto with zarith.
rewrite (proj1 H14), (proj2 H14).
apply S.
Qed.


Lemma analytic_error_debutdeligne :  forall p ni k a dt mem1 mem2 mem3 d,
     separated_matrix p (ni+1) mem1 -> (0 < ni) ->
     (0 <= k)%Z -> (0 < double_exact a)%R ->
     (analytic_error p ni ni k a dt mem1 mem2) -> 
     (mem3=store mem2 (shift (select mem1 (shift p 0)) (k+1)) d) -> 
     double_value d  = 0 ->
     double_exact d  = 0 ->
     (analytic_error p ni 0 (k+1) a dt mem1 mem3).
intros p ni k a dt mem1 mem2 mem3 d H M M' H0 H1 H2 Hd1 Hd2.
unfold analytic_error in H1 |-*.
elim H1; auto with zarith; intros N1 (N2, (H3,(H4, H4'))).
intros; split; intros.
absurd (k+1=0)%Z; auto with zarith.
intros; split; intros.
case (Zle_lt_or_eq 0 k); auto with zarith; intros.
rewrite H2; rewrite separated_matrix_eps; auto with zarith.
rewrite H2; rewrite separated_matrix_eps; auto with zarith.
intros; split; intros.
case H7; intros.
rewrite H2; rewrite separated_matrix_eps; auto with zarith.
case (Zle_lt_or_eq k1 k); auto with zarith; intros.
unfold eps.
generalize (Zcompare_correct 0 i1); case (Zcompare 0 i1).
intros; replace (eps_aux2 p ni a mem1 mem2 i1 k1) with 0%R.
rewrite Rabs_R0; apply Rmult_le_pos; auto with real zarith.
apply Rle_trans with (INR 78); auto with real zarith.
simpl; right; ring.
apply trans_eq with (eps p ni a mem1 mem2 i1 k1).
rewrite <- H10; rewrite eps_0; auto with zarith.
rewrite <- H10; unfold eps; simpl; auto.
unfold eps_aux2.
case (Z_eq_dec ((i1 / ni) mod 2) 0); intros.
assert (0 <= i1 mod ni < ni); auto with zarith.
generalize (Z_mod_lt i1 ni); auto with zarith.
rewrite <- eps_eps_aux; auto with zarith.
rewrite Rabs_Ropp.
assert (0 <= (ni-i1) mod ni < ni); auto with zarith.
generalize (Z_mod_lt (ni-i1) ni); auto with zarith.
rewrite <- eps_eps_aux; auto with zarith.
rewrite Rabs_Ropp.
unfold eps_aux2.
case (Z_eq_dec ((-i1 / ni) mod 2) 0); intros.
assert (0 <= -i1 mod ni < ni); auto with zarith.
generalize (Z_mod_lt (-i1) ni); auto with zarith.
rewrite <- eps_eps_aux; auto with zarith.
rewrite Rabs_Ropp.
assert (0 <= (ni-(-i1)) mod ni < ni); auto with zarith.
generalize (Z_mod_lt (ni-(-i1)) ni); auto with zarith.
rewrite <- eps_eps_aux; auto with zarith.
replace i1 with 0; auto with zarith.
rewrite eps_0; auto with zarith.
simpl (IZR 0); rewrite Rabs_R0; apply Rmult_le_pos; auto with real zarith.
apply Rle_trans with (INR 78); auto with real zarith.
simpl; right; ring.
split; intros.
case H8; intros.
rewrite H2.
rewrite separated_matrix_prop with p mem1 mem2  
    (ni+1) i1 0 k1 (k+1) d; auto with zarith.
rewrite H4; auto with zarith.
unfold Err; apply sum_f_z_eq; auto with zarith; intros.
apply sum_f_z_eq; auto with zarith; intros.
rewrite separated_matrix_eps; auto with zarith.
case (Zle_lt_or_eq k1 k); auto with zarith.
assert (i1 = 0); auto with zarith.
rewrite H10; rewrite Err_0; auto with zarith.
replace (select mem3 (shift (select mem1 (shift p 0)) k1)) with d.
rewrite Hd1, Hd2; ring.
rewrite H2, select_store_eq; trivial.
apply f_equal; now destruct H9.
case H8; intros.
rewrite H2.
apply sym_eq; rewrite <- (H4' i1 k1) at 1; auto with zarith.
apply sym_eq; apply separated_matrix_scheme with ni; auto with zarith.
case (Zle_lt_or_eq k1 k); auto with zarith.
assert (i1 = 0); auto with zarith.
rewrite H10; unfold scheme.
case (Z_lt_le_dec 0 0); intros V.
contradict V; auto with zarith.
replace (select mem3 (shift (select mem1 (shift p 0)) (Zabs_nat k1))) with d; auto.
rewrite H2, select_store_eq; trivial.
apply f_equal; destruct H9; rewrite H9.
rewrite <- Zabs_absolu; rewrite Zabs_eq; auto with zarith.
Qed.



Lemma analytic_error_findeligne : forall p ni k a dt mem1 mem2 mem3 d,
     separated_matrix p (ni+1) mem1 -> (1 <= ni) ->
     (0 <= k)%Z -> (0 < double_exact a)%R ->
     (analytic_error p ni (ni-1) k a dt mem1 mem2) -> 
     (mem3=store mem2 (shift (select mem1 (shift p ni)) k) d) ->
     double_value d  = 0 ->
     double_exact d  = 0 ->
     (analytic_error p ni ni k a dt mem1 mem3).
intros p ni k a dt mem1 mem2 mem3 d H M M' H0 H1 H2 Hd1 Hd2.
unfold analytic_error in H1 |-*.
elim H1; auto with zarith; intros N1 (N2,(H3,(H4,H4'))).
intros; split; intros.
case (Zle_lt_or_eq i1 ni); auto with zarith; intros.
rewrite H2; rewrite separated_matrix_eps; auto with zarith.
replace (eps p ni a mem1 mem3 i1 0) with 0%R.
rewrite Rabs_R0; apply Rmult_le_pos; auto with real zarith.
apply Rle_trans with (INR 14); auto with real zarith.
right; simpl; ring.
rewrite H9; rewrite eps_ni; auto with zarith.
split.
intros.
rewrite H2; rewrite separated_matrix_eps; auto with zarith.
split; intros.
assert ((0 <= k1 < k \/ k1 = k /\ 0 <= i1 <= ni - 1) 
        \/ (k1=k /\ i1=ni)) by omega.
case H8; intros.
rewrite H2; rewrite separated_matrix_eps; auto with zarith.
elim H9; auto with zarith.
replace (eps p ni a mem1 mem3 i1 k1) with 0%R.
rewrite Rabs_R0; apply Rmult_le_pos; auto with real zarith.
apply Rle_trans with (INR 78); auto with real zarith.
right; simpl; ring.
replace i1 with ni; auto with zarith.
rewrite eps_ni; auto with zarith.
rewrite H2.
split; intros.
assert ((0 <= k1 < k \/ k1 = k /\ 0 <= i1 <= ni - 1) 
        \/ (k1=k /\ i1=ni)) by omega.
case H9; intros.
rewrite separated_matrix_prop with p mem1 mem2 
    (ni+1) i1 ni k1 k d; auto with zarith.
rewrite H4; auto with zarith.
unfold Err; apply sum_f_z_eq; auto with zarith; intros.
apply sum_f_z_eq; auto with zarith; intros.
rewrite separated_matrix_eps; auto with zarith.
case (Zle_lt_or_eq 0 k0); auto with zarith.
intros; case H10; auto with zarith.
case H10; auto with zarith.
case H10; auto with zarith.
replace i1 with ni; auto with zarith.
replace k1 with k; auto with zarith.
replace  (select (store mem2 (shift (select mem1 (shift p ni)) k) d)
      (shift (select mem1 (shift p ni)) k)) with d. 
rewrite Hd1, Hd2.
rewrite Err_ni; simpl; auto with zarith real.
now rewrite select_store_eq.
assert ((0 <= k1 < k \/ k1 = k /\ 0 <= i1 <= ni - 1) 
        \/ (k1=k /\ i1=ni)) by omega.
case H9; intros.
apply sym_eq; rewrite <- (H4' i1 k1) at 1; auto with zarith.
apply sym_eq; apply separated_matrix_scheme with ni; auto with zarith.
case H10; auto with zarith.
case H10; auto with zarith.
replace i1 with ni; auto with zarith.
replace k1 with k; auto with zarith.
unfold scheme.
case (Z_lt_le_dec 0 ni); intros V.
case (Z_lt_le_dec ni (R_n.ni 0 1 (fst (/ ni, double_exact dt)))); intros V'.
absurd (ni = R_n.ni 0 1 (fst (/ni, double_exact dt))); auto with zarith.
simpl; unfold R_n.ni, jx.
replace ((1 - 0) / /ni )%R with (IZR ni).
apply sym_eq; apply Int_part_IZR.
field; auto with zarith real.
rewrite <- Zabs_absolu; rewrite Zabs_eq; auto with zarith.
replace  (select (store mem2 (shift (select mem1 (shift p ni)) k) d)
      (shift (select mem1 (shift p ni)) k)) with d; auto. 
now rewrite select_store_eq.
rewrite <- Zabs_absolu; rewrite Zabs_eq; auto with zarith.
replace  (select (store mem2 (shift (select mem1 (shift p ni)) k) d)
      (shift (select mem1 (shift p ni)) k)) with d; auto. 
now rewrite select_store_eq.
Qed.

(* Why obligation from file "dirichlet.c", line 85, characters 5-608: *)
(*Why goal*) Lemma analytic_error_le : 
  (forall (double_xP_double_xM_p_0_10_at_L:(memory double_xP (pointer doubleP))),
   (forall (doubleP_doubleM_double_xM_11_at_L:(memory doubleP double)),
    (forall (p_0:(pointer double_xP)),
     (forall (ni_0_0:Z),
      (forall (i_2:Z),
       (forall (nk_0:Z),
        (forall (k_0:Z),
         (forall (a_0:double),
          (forall (dt_6:double),
           (0 < ni_0_0 ->
            (0 <= i_2 /\ i_2 <= ni_0_0 ->
             (0 <= k_0 ->
              ((Rlt (0)%R (double_exact dt_6)) ->
               ((analytic_error
                 p_0 ni_0_0 i_2 k_0 a_0 dt_6 double_xP_double_xM_p_0_10_at_L doubleP_doubleM_double_xM_11_at_L) ->
                ((Rlt
                  (sqrt
                   (Rplus
                    (Rdiv (1)%R (IZR (ni_0_0 * ni_0_0))) (Rmult
                                                          (double_exact dt_6) (
                                                          double_exact dt_6))))
                  alpha_conv) ->
                 (k_0 <= nk_0 ->
                  (nk_0 <= 7598581 ->
                   ((Rle (Rmult (IZR nk_0) (double_exact dt_6)) T_max) ->
                    ((Rle (Rmult (Rmult (double_exact dt_6) (IZR ni_0_0)) c)
                      (Rminus (1)%R (1 / 1125899906842624)%R)) ->
                     (forall (i1:Z),
                      (forall (k1:Z),
                       (0 <= i1 /\ i1 <= ni_0_0 ->
                        (0 <= k1 /\ k1 < k_0 ->
                         (Rle
                          (Rabs
                           (double_value
                            (select
                             doubleP_doubleM_double_xM_11_at_L (shift
                                                                (select
                                                                 double_xP_double_xM_p_0_10_at_L (
                                                                 shift p_0 i1)) k1))))
                          (2)%R)))))))))))))))))))))))).
Proof.
intros mem1 mem2 p ni i nk k a dt H H1 H2 H3 H4 H5 H6 H7 H8 H9 i1 k1 H10 H11.
pose (accM  := 
 fun (i j:Z) => select mem2 (shift (select mem1 (shift p i)) j)).
fold (accM i1 k1).
replace 2%R with (1 +/2+/2)%R by field.
replace (double_value (accM i1 k1)) with
   (ubar 0 (fun X => psol (fst X) (snd X)) (/ni, double_exact dt) i1 (Zabs_nat k1)
     + (double_exact (accM i1 k1) - ubar 0 (fun X => psol (fst X) (snd X)) (/ni, double_exact dt) i1 (Zabs_nat k1))
     + (double_value (accM i1 k1) - double_exact (accM i1 k1)))%R by ring.
apply Rle_trans with (1:=Rabs_triang _ _).
apply Rplus_le_compat.
apply Rle_trans with (1:=Rabs_triang _ _).
apply Rplus_le_compat.
(* . *)
apply psol_le.
unfold Xjk; simpl.
rewrite Rplus_0_l; split.
apply Rmult_le_pos; auto with real zarith.
apply Rmult_le_reg_l with (IZR ni);auto with real zarith.
rewrite Rmult_1_r.
apply Rle_trans with (IZR i1); auto with real zarith.
right; field; auto with real zarith.
unfold Xjk; simpl.
apply Rmult_le_pos; auto with real zarith.
(* . *)
cut (norm_l2 (/ni, double_exact dt) < alpha_conv)%R.
2: apply Rle_lt_trans with (2:=H5).
2: right; unfold norm_l2, Rsqr; simpl.
2: apply f_equal; rewrite mult_IZR; field; auto with real zarith.
unfold alpha_conv.
destruct ((construct_alpha (/ (2 * C_conv))
         (Rinv_0_lt_compat (2 * C_conv)
            (Rmult_lt_0_compat 2 C_conv Rlt2 C_conv_pos)))) as (alp1,H13).
simpl; generalize H13; clear H13.
unfold alpha_aux, C_conv.
destruct (convergence 0%R 1%R T_max Rlt_0_1 T_max_pos 
    Derx Dery
    c (fun X => psol (fst X) (snd X)) p0 (fun _ => 0) (fun _ => 0) 
    (my_unh 0 1 c p0h (fun _ _ => 0) (fun _ _ _ => 0))  (1 / 1125899906842624)%R) as (alp2,H14).
case H14; clear H14; intros C H14.
case H14; clear H14; intros H15 H14.
case H14; clear H14; intros H16 H14 H13 H17.
assert (Vk: Under T_max (INR (Zabs_nat k1)*snd (/ni, double_exact dt))).
split; simpl.
apply Rmult_le_pos; auto with real zarith.
apply Rle_trans with (2:=H8).
apply Rmult_le_compat_r; auto with real zarith.
rewrite INR_IZR_INZ; rewrite inj_abs; auto with real zarith.
case (Zle_lt_or_eq i1 ni); auto with zarith; intros H12.
(* .. *)
(* ... *)
assert ((Rabs (convergence_error 0 (fun X0 : R * R => psol (fst X0) (snd X0))
              (my_unh 0 1 c p0h (fun (_ : R * R) (_ : Z) => Z0)
                 (fun (_ : R * R) (_ : Z) (_ : nat) => Z0)) (/ni, double_exact dt) i1
              (kt (projT1 (existT (Under T_max) _  Vk)) (snd (/ni, double_exact dt))))
    <= (C * Rabs (fst (/ni, double_exact dt) ^ 2 + snd (/ni, double_exact dt) ^ 2)) 
            / sqrt (fst (/ni, double_exact dt))))%R.
apply finite_norm_le_reverse with (xmin:=0) (xmax:=1) 
  (uh:=(fun j => (convergence_error 0 (fun X0 : R * R => psol (fst X0) (snd X0))
      (my_unh 0 1 c p0h (fun (_ : R * R) (_ : Z) => Z0)
         (fun (_ : R * R) (_ : Z) (_ : nat) => Z0)) (/ ni, double_exact dt)
      j
      (kt
         (projT1
            (existT (Under T_max) (Zabs_nat k1 * snd (/ ni, double_exact dt))%R
               Vk)) (snd (/ ni, double_exact dt)))))); auto with zarith real.
simpl; auto with zarith real.
rewrite <- (Rabs_right (finite_norm_dx Z0 1%Z (fst (/ ni, double_exact dt))
   (fun j : Z =>
    convergence_error 0 (fun X0 : R * R => psol (fst X0) (snd X0))
      (my_unh 0 1 c p0h (fun (_ : R * R) (_ : Z) => Z0)
         (fun (_ : R * R) (_ : Z) (_ : nat) => Z0)) (/ ni, double_exact dt) j
      (kt
         (projT1
            (existT (Under T_max) (Zabs_nat k1 * snd (/ ni, double_exact dt))%R
               Vk)) (snd (/ ni, double_exact dt)))))).
apply H14 with (X:=(existT (Under T_max)
                  (Zabs_nat k1 * snd (/ ni, double_exact dt))%R Vk)).
apply Rlt_le_trans with (1:=H17).
apply Rmin_l.
split.
simpl; auto with real zarith.
split.
simpl; auto with real zarith.
split.
unfold CFL_condition_r, CFL; simpl.
apply Rle_trans with (2:=H9).
right; field; auto with real zarith.
unfold ni_exact, R_n.ni,jx; simpl.
replace ((1 - 0) / / ni)%R with (IZR ni).
rewrite Int_part_IZR; auto.
field; auto with real zarith.
apply Rle_ge. 
unfold finite_norm_dx.
apply Reals_compl.sqrt_pos.
replace (R_n.ni Z0 1%Z (fst (/ ni, double_exact dt))) with ni; auto with zarith.
unfold R_n.ni,jx; simpl.
replace ((1 - 0) / / ni)%R with (IZR ni).
rewrite Int_part_IZR; auto.
field; auto with real zarith.
(* ... *)
simpl in H0.
apply Rle_trans with (Rabs
        (convergence_error 0 (fun X0 : R * R => psol (fst X0) (snd X0))
           (my_unh 0 1 c p0h (fun (_ : R * R) (_ : Z) => 0)
              (fun (_ : R * R) (_ : Z) (_ : nat) => 0))
           (/ ni, double_exact dt) i1
           (kt (Zabs_nat k1 * double_exact dt) (double_exact dt)))).
right; unfold Rminus; rewrite <- Rabs_Ropp, Rplus_comm.
apply f_equal.
unfold convergence_error.
rewrite Ropp_plus_distr; apply Rplus_eq_compat.
rewrite Ropp_involutive.
replace  (kt (Zabs_nat k1 * double_exact dt) (double_exact dt)) with (Zabs_nat k1).
auto.
unfold kt; apply f_equal.
replace (Zabs_nat k1 * double_exact dt / double_exact dt)%R with (INR (Zabs_nat k1)).
rewrite Int_part_INR.
rewrite inj_abs; auto with zarith.
field; auto with real.
apply f_equal.
replace  (kt (Zabs_nat k1 * double_exact dt) (double_exact dt)) with (Zabs_nat k1).
pattern k1 at 1; replace k1 with (Z_of_nat (Zabs_nat k1)).
apply scheme_eq with 
  (unh1 := fun _ j n => double_exact (accM j n))
  (unh2 := fun _ j n => my_unh 0 1 c p0h (fun (_ : R * R) (_ : Z) => Z0)
    (fun (_ : R * R) (_ : Z) (_ : nat) => Z0)
     (/ ni , double_exact dt) j n)
  (j:=i1) (n:=Zabs_nat k1) (xmin:=0) (xmax:=1) (c:=c) (u0h:=p0h) (u1h:=fun _ _=> 0) (fh := fun _ _ _ =>0)
  (nmax:=Zabs_nat (k-1)) (dX:= (/ ni, double_exact dt)).
simpl; auto with real.
intros; apply trans_eq with 0%R.
destruct H4 as (_,(_,(_,(_,Z)))); auto with zarith.
replace n with (Zabs_nat (Z_of_nat n)).
apply Z; auto with zarith.
replace ni with 
 (R_n.ni Z0 1%Z (fst (/ ni, double_exact dt))); try assumption.
unfold R_n.ni, jx; simpl.
replace ((1 - 0) / / ni)%R with (IZR ni).
apply Int_part_IZR.
field; auto with real zarith.
left.
split; auto with zarith.
replace k with (Z_of_nat (Zabs_nat (k-1))+1); auto with zarith.
rewrite inj_abs; auto with zarith.
rewrite Zabs_nat_Z_of_nat; auto with zarith.
apply sym_eq; simpl.
generalize (my_unh_correct 0 1 c p0h (fun _ _ => 0) (fun _ _ _ =>0)); unfold is_discrete_solution.
intros T; apply T; auto.
simpl; auto with real.
replace (R_n.ni Z0 1%Z (fst (/ ni, double_exact dt))) with ni; auto with zarith.
unfold R_n.ni, jx; simpl.
replace ((1 - 0) / / ni)%R with (IZR ni).
rewrite Int_part_IZR; auto with zarith.
field; auto with real zarith.
apply ZleLe.
rewrite 2!inj_abs; auto with zarith.
rewrite inj_abs; auto with zarith.
unfold kt; apply f_equal.
replace (Zabs_nat k1 * double_exact dt / double_exact dt)%R 
   with (INR (Zabs_nat k1)).
rewrite Int_part_INR; auto with zarith.
rewrite inj_abs; auto with zarith.
field; auto with real.
apply Rle_trans with (1:=H0).
apply Rmult_le_reg_l with (/C); auto with real.
rewrite 2!Rmult_1_r; unfold Rdiv.
rewrite <- 2!Rmult_assoc, Rinv_l; auto with real.
rewrite Rmult_1_l.
replace (/C*/2)%R with (/(2*C)) by (field; auto with real).
apply Rle_trans with (((/ni * /ni + double_exact dt * double_exact dt) / sqrt (/ni)))%R.
rewrite Rabs_right.
unfold Rdiv; auto with real.
apply Rle_ge; apply Rle_trans with (0+0)%R; auto with real.
apply Rplus_le_compat; apply Rmult_le_pos; auto with real zarith.
apply H13; auto with real zarith.
left; apply Rlt_le_trans with (Rmin alp2 (Rmin alp1 1)).
apply Rle_lt_trans with (2:=H17).
unfold norm_l2, Rsqr; simpl; auto with real.
apply Rle_trans with (1:=Rmin_r _ _).
apply Rmin_l.
apply Rle_trans with (1 - 1 / 1125899906842624)%R.
apply Rle_trans with (2:=H9).
right; field; auto with real zarith.
rewrite powerRZ_50_eq.
apply Rle_trans with (1-0)%R; auto with real.
apply Rplus_le_compat_l; apply Ropp_le_contravar.
auto with real zarith.
(* .. *)
rewrite H12.
unfold ubar, discretization, Xjk; simpl.
replace (0+ni*/ni)%R with 1%R.
2: field; auto with real zarith.
rewrite wave_eq_dirichlet_2.
replace (double_exact (accM ni k1)) with 0%R.
rewrite Rminus_0_r, Rabs_R0.
auto with real.
destruct H4 as (_,(_,(_,(_,Z)))); auto with zarith.
specialize (Z ni k1); simpl in Z.
rewrite <- Z; auto with zarith.
unfold scheme.
case (Z_lt_le_dec 0 ni).
2: intros V; contradict V; auto with zarith.
intros _.
replace (R_n.ni 0 1 (fst (/ ni, double_exact dt))) with ni.
2: unfold R_n.ni, jx; simpl.
2: replace ((1 - 0) / / ni)%R with (IZR ni).
2: rewrite Int_part_IZR; auto with zarith.
2: field; auto with real zarith.
case (Z_lt_le_dec ni ni).
intros V; contradict V; auto with zarith.
intros _; unfold accM.
rewrite inj_abs; auto with zarith.
(* . *)
apply Rle_trans with (double_round_error (select mem2 (shift (select mem1 (shift p i1)) k1))).
right; reflexivity.
apply Rle_trans with  (78 * powerRZ 2 (-52) * ((k1 + 1) * (k1 + 2) / 2))%R.
apply analytic_error_implies_error1 with (1:=H4); auto with zarith.
rewrite <- (Rmult_1_l (/2)).
unfold Rdiv; repeat rewrite <- Rmult_assoc.
apply Rmult_le_compat_r; auto with real.
apply Rmult_le_reg_l with (powerRZ 2 52); auto with real zarith.
rewrite Rmult_1_r.
apply Rle_trans with ((powerRZ 2 52*powerRZ 2 (-52))*78*(k1+1)*(k1+2))%R.
right; ring.
rewrite <- powerRZ_add; auto with real.
replace (52+-52)%Z with 0%Z by ring.
simpl (powerRZ 2 0); rewrite Rmult_1_l.
replace 78%R with (IZR 78) by (simpl; ring).
replace 2%R with (IZR 2) by (simpl; ring).
replace 1%R with (IZR 1) by (simpl; ring).
rewrite <- 2!plus_IZR, <- 2!mult_IZR.
apply Rle_trans with (IZR 4503599627370496).
apply Rle_IZR.
clear - H11 H6 H7.
apply Zle_trans with (78*(7598581+1)*(7598581+2))%Z.
rewrite <- 2!Zmult_assoc.
apply Zmult_le_compat_l; auto with zarith.
apply Zmult_le_compat; auto with zarith.
omega.
rewrite <- Z2R_IZR.
simpl; rewrite Rmult_1_r.
now right.
Save.

(* Recursive Extraction C_conv. *)

